#!/usr/bin/env nomsu -V7.0.0-- File lib/base64/init.nom chunk #1
local b64x5Fstr, b64x5Fchars, reversex5Fb64;
-- 
-- This file defines actions for encoding/decoding base 64, as specified in:
-- https://tools.ietf.org/html/rfc4648
-- ;
b64x5Fstr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
b64x5Fchars = a_List(function(add)
    do -- for-loop
        local _start = 1
    for _=_start,(#b64x5Fstr) do
            add(b64x5Fstr:character(_));
        end
    end -- for-loop;
end);
reversex5Fb64 = a_Dict(function(add, add_1_x3D)
    do -- for-loop
        for i,c in pairs(b64x5Fchars) do
            add_1_x3D(c, i - 1);
        end
    end -- for-loop;
end);
reversex5Fb64["="] = 64;
setmetatable(reversex5Fb64, a_Dict{
    __index = (function()
        return 0
    end);
});
TESTS["@lib/base64/init.nom[448:707]"] = "\n$cases = [\"\", \"Zg==\", \"Zm8=\", \"Zm9v\", \"Zm9vYg==\", \"Zm9vYmE=\", \"Zm9vYmFy\"]\nfor ($len = $encoded) in $cases:\n    $plain = (\"foobar\", from 1 to ($len - 1))\n    assume (base64 $plain) == $encoded\n    assume (base64 decode $encoded) == $plain";
base64 = (function(str)
    local chars, bytes;
    chars = a_List{};
    do -- for-loop
        local _start, _step = 1, 3;
    for i=_start,(#str),_step do
            bytes = a_List{str:byte(i, i + 2)};
    chars:add(b64x5Fchars[(Bit.rshift(Bit.band(bytes[1], 252), 2)) + 1]);
    do --if $ is...
        local branch_valuex030 = (#bytes)
        if branch_valuex030 == 3 then
        chars:add(
            b64x5Fchars[(Bit.lshift(Bit.band(bytes[1], 3), 4)) + (Bit.rshift(Bit.band(bytes[2], 240), 4)) + 1]);
        chars:add(
            b64x5Fchars[(Bit.lshift(Bit.band(bytes[2], 15), 2)) + (Bit.rshift(Bit.band(bytes[3], 192), 6)) + 1]);
        chars:add(b64x5Fchars[(Bit.band(bytes[3], 63)) + 1]);
    elseif branch_valuex030 == 2 then
        chars:add(
            b64x5Fchars[(Bit.lshift(Bit.band(bytes[1], 3), 4)) + (Bit.rshift(Bit.band(bytes[2], 240), 4)) + 1]);
        chars:add(b64x5Fchars[(Bit.lshift(Bit.band(bytes[2], 15), 2)) + 1]);
        chars:add("=");
    elseif branch_valuex030 == 1 then
        chars:add(b64x5Fchars[(Bit.lshift(Bit.band(bytes[1], 3), 4)) + 1]);
        chars:add("=");
        chars:add("=");
    end --when
    end -- if $ is...;
        end
    end -- for-loop;
    do return chars:joined() end
end);
base64_encode = base64;
_1_base64 = base64;
chr = (function(_)
    return string.char(_)
end);
decode_base64 = (function(str)
    local chars, indices;
    chars = a_List{};
    do -- for-loop
        local _start, _step = 1, 4;
    for i=_start,(#str),_step do
            indices = a_List(function(add)
        do -- for-loop
            local _start = i
        for j=_start,i + 3 do
                add(reversex5Fb64[str:character(j)]);
            end
        end -- for-loop;
    end);
    chars:add(
        chr((Bit.lshift(indices[1], 2)) + (Bit.rshift(Bit.band(indices[2], 48), 4))));
    if (str:character(i + 2) == "=") then
        break;
    end
    chars:add(
        chr(
            (Bit.lshift(Bit.band(indices[2], 15), 4)) + (Bit.rshift(Bit.band(indices[3], 60), 2))));
    if (str:character(i + 3) == "=") then
        break;
    end
    chars:add(chr((Bit.lshift(Bit.band(indices[3], 3), 6)) + indices[4]));
        end
    end -- for-loop;
    do return chars:joined() end
end);
_1_base64_decoded = decode_base64;
base64_decode = decode_base64;
