#!/usr/bin/env nomsu -V7.0.0-- File lib/core/collections.nom chunk #1
-- 
-- This file contains code that supports manipulating and using collections like lists
-- and dictionaries.
-- ;
_ENV:use("core/metaprogramming");
_ENV:use("core/control_flow");
_ENV:use("core/operators");

-- File lib/core/collections.nom chunk #2
--  List functionality:;
TESTS["@lib/core/collections.nom[332:958]"] = "\n$list = [1, 2, 3, 4, 5]\n$visited = {}\nfor ($i = $x) in $list:\n    $visited.$i = (yes)\nassume ($visited == {.1, .2, .3, .4, .5})\n$visited = {}\nfor $x in $list:\n    $visited.$x = (yes)\nassume ($visited == {.1, .2, .3, .4, .5})\nassume (($list, 2 nd to last) == 4)\nassume (($list, first) == 1)\nassume ($list, has 3)\nassume (($list, index of 3) == 3)\nassume (#$list == 5)\n$list, add 6\nassume (($list, last) == 6)\n$list, pop\nassume (($list, last) == 5)\n$list, remove index 1\nassume (($list, first) == 2)\nassume (([1, 2] + [3, 4]) == [1, 2, 3, 4])";
--  Dict functionality;
TESTS["@lib/core/collections.nom[987:2517]"] = "\n$dict = {.x = 1, .y = 2, .z = 3}\nassume #$dict == 3\nassume [: for ($k = $v) in {.x = 1}: add {.key = $k, .value = $v}] ==\n    [{.key = \"x\", .value = 1}]\nassume ({.x = 1, .y = 1} + {.y = 10, .z = 10}) == {.x = 1, .y = 11, .z = 10}\nassume ({.x = 1, .y = 1} - {.y = 10, .z = 10}) == {.x = 1, .y = -9, .z = -10}\nassume ({.x = 1, .y = 1} | {.y = 10, .z = 10}) == {.x = 1, .y = 1, .z = 10}\nassume ({.x = 1, .y = 1} & {.y = 10, .z = 10}) == {.y = 1}\nassume ({.x = 1, .y = 1} ~ {.y = 10, .z = 10}) == {.x = 1, .z = 10}\n\n### Set compliments:\nassume (~{.x}).y\nassume ((~{.x}).x == (nil))\n$sc = ~{.x, .y}\n$sc.y = 99\n\n### For now, whether $sc.y == 99 or $sc.y == (yes) is unspecified,\n    (but the actual behavior is (yes))\nassume ($sc.y and (not $sc.x))\nassume ($sc == (~{.x, .y} | {.y = 99}))\n\n### Both sets:\nassume (({.x, .y} & {.y, .z}) == {.y})\nassume (({.x, .y} | {.y, .z}) == {.x, .y, .z})\nassume (({.x, .y} ~ {.y, .z}) == {.z, .x})\n\n### Mixed:\nassume (({.x, .y} & ~{.y, .z}) == {.x})\nassume (({.x, .y} | ~{.y, .z}) == ~{.z})\nassume (({.x, .y} ~ ~{.y, .z}) == ~{.x})\n\n### Mixed reversed:\nassume ((~{.y, .z} & {.x, .y}) == {.x})\nassume ((~{.y, .z} | {.x, .y}) == ~{.z})\nassume ((~{.y, .z} ~ {.x, .y}) == ~{.x})\n\n### Both set compliments:\nassume ((~{.x, .y} & ~{.y, .z}) == ~{.x, .y, .z})\nassume ((~{.x, .y} | ~{.y, .z}) == ~{.y})\nassume ((~{.x, .y} ~ ~{.y, .z}) == {.x, .z})";
TESTS["@lib/core/collections.nom[2523:2589]"] = "\nassume ((entries in {.x = 1}) == [{.key = \"x\", .value = 1}])";
COMPILE_RULES["entries in"] = (function(_ENV, _tree, dict)
    local mangle = mangler()
    return SyntaxTree{SyntaxTree{SyntaxTree{"for", SyntaxTree{SyntaxTree{mangle("k"), type="Var", source="@lib/core/collections.nom[2632:2634]"}, "=", SyntaxTree{mangle("v"), type="Var", source="@lib/core/collections.nom[2637:2639]"}, type= "Action", source= "@lib/core/collections.nom[2632:2639]", stub= "1 ="}, "in", dict, SyntaxTree{SyntaxTree{"add", SyntaxTree{SyntaxTree{SyntaxTree{SyntaxTree{"key", type= "Text", source= "@lib/core/collections.nom[2657:2660]"}, type= "Index", source= "@lib/core/collections.nom[2656:2660]"}, "=", SyntaxTree{mangle("k"), type="Var", source="@lib/core/collections.nom[2663:2665]"}, type= "Action", source= "@lib/core/collections.nom[2656:2665]", stub= "1 ="}, SyntaxTree{SyntaxTree{SyntaxTree{"value", type= "Text", source= "@lib/core/collections.nom[2668:2673]"}, type= "Index", source= "@lib/core/collections.nom[2667:2673]"}, "=", SyntaxTree{mangle("v"), type="Var", source="@lib/core/collections.nom[2676:2678]"}, type= "Action", source= "@lib/core/collections.nom[2667:2678]", stub= "1 ="}, type= "Dict", source= "@lib/core/collections.nom[2655:2679]"}, type= "Action", source= "@lib/core/collections.nom[2651:2679]", stub= "add"}, type= "Block", source= "@lib/core/collections.nom[2649:2679]"}, type= "Action", source= "@lib/core/collections.nom[2627:2679]", stub= "for 1 in"}, type= "Block", source= "@lib/core/collections.nom[2625:2679]"}, type= "List", source= "@lib/core/collections.nom[2624:2680]"}
end);
TESTS["@lib/core/collections.nom[2686:2728]"] = "\nassume ((keys in {.x = 1}) == [\"x\"])";
COMPILE_RULES["keys in"] = (function(_ENV, _tree, dict)
    local mangle = mangler()
    return SyntaxTree{SyntaxTree{SyntaxTree{"for", SyntaxTree{SyntaxTree{mangle("k"), type="Var", source="@lib/core/collections.nom[2782:2784]"}, "=", SyntaxTree{mangle("v"), type="Var", source="@lib/core/collections.nom[2787:2789]"}, type= "Action", source= "@lib/core/collections.nom[2782:2789]", stub= "1 ="}, "in", dict, SyntaxTree{SyntaxTree{"add", SyntaxTree{mangle("k"), type="Var", source="@lib/core/collections.nom[2805:2807]"}, type= "Action", source= "@lib/core/collections.nom[2801:2807]", stub= "add"}, type= "Block", source= "@lib/core/collections.nom[2799:2807]"}, type= "Action", source= "@lib/core/collections.nom[2777:2807]", stub= "for 1 in"}, type= "Block", source= "@lib/core/collections.nom[2775:2807]"}, type= "List", source= "@lib/core/collections.nom[2774:2808]"}
end)
COMPILE_RULES["keys of"] = COMPILE_RULES["keys in"];
TESTS["@lib/core/collections.nom[2813:2855]"] = "\nassume ((values in {.x = 1}) == [1])";
COMPILE_RULES["values in"] = (function(_ENV, _tree, dict)
    local mangle = mangler()
    return SyntaxTree{SyntaxTree{SyntaxTree{"for", SyntaxTree{SyntaxTree{mangle("k"), type="Var", source="@lib/core/collections.nom[2917:2919]"}, "=", SyntaxTree{mangle("v"), type="Var", source="@lib/core/collections.nom[2922:2924]"}, type= "Action", source= "@lib/core/collections.nom[2917:2924]", stub= "1 ="}, "in", dict, SyntaxTree{SyntaxTree{"add", SyntaxTree{mangle("v"), type="Var", source="@lib/core/collections.nom[2940:2942]"}, type= "Action", source= "@lib/core/collections.nom[2936:2942]", stub= "add"}, type= "Block", source= "@lib/core/collections.nom[2934:2942]"}, type= "Action", source= "@lib/core/collections.nom[2912:2942]", stub= "for 1 in"}, type= "Block", source= "@lib/core/collections.nom[2910:2942]"}, type= "List", source= "@lib/core/collections.nom[2909:2943]"}
end)
COMPILE_RULES["values of"] = COMPILE_RULES["values in"];
--  Metatable stuff;
TESTS["@lib/core/collections.nom[2969:3065]"] = "\n$t = {}\nset $t's metatable to {.__tostring = ($ -> \"XXX\")}\nassume (\"\\$t\" == \"XXX\")";
COMPILE_RULES["set 1 ' s metatable to"] = (function(_ENV, _tree, dict, metatable)
    return LuaCode:from("@lib/core/collections.nom[3121:3185]", "setmetatable(",
        _ENV:_1_as_lua_expr(dict), ", ", _ENV:_1_as_lua_expr(metatable), ");")
end);
COMPILE_RULES["1 ' s metatable"] = (function(_ENV, _tree, _)
    return LuaCode:from("@lib/core/collections.nom[3231:3263]", "getmetatable(",
        _ENV:_1_as_lua_expr(_), ")")
end)
COMPILE_RULES["1 ' metatable"] = COMPILE_RULES["1 ' s metatable"];
TESTS["@lib/core/collections.nom[3268:3323]"] = "\nassume (({} with fallback $ -> ($ + 1)).10 == 11)";
COMPILE_RULES["1 with fallback 2 ->"] = (function(_ENV, _tree, dict, key, value)
    return LuaCode:from("@lib/core/collections.nom[3374:3737]", "",
        LuaCode:from("@lib/core/collections.nom[3381:3398]", "(function(d)\n"),
        LuaCode:from("@lib/core/collections.nom[3398:3420]", "    local mt = {}\n"),
        LuaCode:from("@lib/core/collections.nom[3420:3485]",
            "    for k,v in pairs(getmetatable(d) or {}) do mt[k] = v end\n"),
        LuaCode:from("@lib/core/collections.nom[3485:3517]",
            "    mt.__index = function(self, "), _ENV:_1_as_lua_expr(key),
        LuaCode:from("@lib/core/collections.nom[3536:3542]", ")\n"),
        LuaCode:from("@lib/core/collections.nom[3542:3564]", "        local value = "),
        _ENV:_1_as_lua_expr(value), "\n",
        LuaCode:from("@lib/core/collections.nom[3590:3603]", "        self["),
        _ENV:_1_as_lua_expr(key),
        LuaCode:from("@lib/core/collections.nom[3622:3636]", "] = value\n"),
        LuaCode:from("@lib/core/collections.nom[3636:3661]", "        return value\n"),
        LuaCode:from("@lib/core/collections.nom[3661:3673]", "    end\n"),
        LuaCode:from("@lib/core/collections.nom[3673:3708]",
            "    return setmetatable(d, mt)\n"),
        LuaCode:from("@lib/core/collections.nom[3708:3713]", "end)("),
        _ENV:_1_as_lua_expr(dict),
        LuaCode:from("@lib/core/collections.nom[3733:3734]", ")"))
end);
--  Sorting;
TESTS["@lib/core/collections.nom[3755:3963]"] = "\n$x = [3, 1, 2]\nsort $x\nassume ($x == [1, 2, 3])\nsort $x by $ = -$\nassume ($x == [3, 2, 1])\n$keys = {.1 = 999, .2 = 0, .3 = 50}\nsort $x by $ = $keys.$\nassume ($x == [2, 3, 1])";
COMPILE_RULES["sort"] = (function(_ENV, _tree, items)
    return LuaCode:from("@lib/core/collections.nom[3990:4026]", "table.sort(",
        _ENV:_1_as_lua_expr(items), ");")
end);
COMPILE_RULES["sort 1 by 2 ="] = (function(_ENV, _tree, items, item, keyx5Fexpr)
    local mangle = mangler()
    return SyntaxTree{"do", SyntaxTree{SyntaxTree{SyntaxTree{mangle("keys"), type="Var", source="@lib/core/collections.nom[4128:4133]"}, "=", SyntaxTree{SyntaxTree{type= "Dict", source= "@lib/core/collections.nom[4137:4139]"}, "with", "fallback", item, "->", keyx5Fexpr, type= "Action", source= "@lib/core/collections.nom[4137:4172]", stub= "1 with fallback 2 ->"}, type= "Action", source= "@lib/core/collections.nom[4128:4173]", stub= "1 ="}, SyntaxTree{"lua", ">", SyntaxTree{"table.sort(", items, ", function(x,y) return ", SyntaxTree{mangle("keys"), type="Var", source="@lib/core/collections.nom[4230:4235]"}, "[x] < ", SyntaxTree{mangle("keys"), type="Var", source="@lib/core/collections.nom[4242:4247]"}, "[y] end)", type= "Text", source= "@lib/core/collections.nom[4187:4256]"}, type= "Action", source= "@lib/core/collections.nom[4182:4256]", stub= "lua >"}, type= "Block", source= "@lib/core/collections.nom[4118:4256]"}, type= "Action", source= "@lib/core/collections.nom[4116:4256]", stub= "do"}
end)
COMPILE_RULES["sort 1 by 2 ->"] = COMPILE_RULES["sort 1 by 2 ="];

-- File lib/core/collections.nom chunk #3
local rangex5Fmt;
TESTS["@lib/core/collections.nom[4358:4408]"] = "\nassume ((sorted [3, 1, 2]) == [1, 2, 3])";
_1_sorted = (function(items)
    local copy;
    copy = a_List(function(add)
        do -- for-loop
            for _i,_ in _ipairs(items) do
                add(_);
            end
        end -- for-loop;
    end);
    table.sort(copy);
    do return copy end
end);
sorted = _1_sorted;
COMPILE_RULES["1 sorted by 2 ="] = (function(_ENV, _tree, items, item, key)
    local mangle = mangler()
    return SyntaxTree{"result", "of", SyntaxTree{SyntaxTree{SyntaxTree{mangle("copy"), type="Var", source="@lib/core/collections.nom[4659:4664]"}, "=", SyntaxTree{SyntaxTree{SyntaxTree{"for", SyntaxTree{mangle(""), type="Var", source="@lib/core/collections.nom[4674:4675]"}, "in", items, SyntaxTree{SyntaxTree{"add", SyntaxTree{mangle(""), type="Var", source="@lib/core/collections.nom[4691:4692]"}, type= "Action", source= "@lib/core/collections.nom[4687:4692]", stub= "add"}, type= "Block", source= "@lib/core/collections.nom[4685:4692]"}, type= "Action", source= "@lib/core/collections.nom[4670:4692]", stub= "for 1 in"}, type= "Block", source= "@lib/core/collections.nom[4668:4692]"}, type= "List", source= "@lib/core/collections.nom[4667:4693]"}, type= "Action", source= "@lib/core/collections.nom[4659:4693]", stub= "1 ="}, SyntaxTree{"sort", SyntaxTree{mangle("copy"), type="Var", source="@lib/core/collections.nom[4711:4716]"}, "by", item, "=", key, type= "Action", source= "@lib/core/collections.nom[4706:4732]", stub= "sort 1 by 2 ="}, SyntaxTree{"return", SyntaxTree{mangle("copy"), type="Var", source="@lib/core/collections.nom[4752:4757]"}, type= "Action", source= "@lib/core/collections.nom[4745:4757]", stub= "return"}, type= "Block", source= "@lib/core/collections.nom[4645:4757]"}, type= "Action", source= "@lib/core/collections.nom[4636:4757]", stub= "result of"}
end)
COMPILE_RULES["1 sorted by 2 ->"] = COMPILE_RULES["1 sorted by 2 ="];
TESTS["@lib/core/collections.nom[4771:4830]"] = "\nassume ((unique [1, 2, 1, 3, 2, 3]) == [1, 2, 3])";
unique = (function(items)
    local unique, seen;
    unique = a_List{};
    seen = a_Dict{};
    do -- for-loop
        for _i,_ in _ipairs(items) do
            if (not seen[_]) then
        unique:add(_);
    seen[_] = (true);
    end
        end
    end -- for-loop;
    do return unique end
end);
--  Ranges:;
TESTS["@lib/core/collections.nom[5068:5462]"] = "\n$r = (3 to 5)\nassume ($r.2 == 4)\nassume ($r is \"a Range\")\nassume ((1 to 10, backwards) == (10 to 1 by -1))\nassume (#(1 to 10 by 2) == 5)\n$visited = []\nfor $ in (1 to 10 by 2):\n    $visited, add $\nassume ($visited == [1, 3, 5, 7, 9])\n$r = (1 to 10 by 2)\n$visited = []\nfor $ in $r:\n    $visited, add $\nassume ($visited == [1, 3, 5, 7, 9])";
rangex5Fmt = a_Dict{
    __type = "a Range"; __index = (function(self, key)
        local i;
        if _1_is(key, "a Number") then
            if (((key) % (1)) ~= 0) then
            do return (nil) end
        end
        i = self.first + (key - 1) * self.step;
        if (self.step > 0) then
            if (i > self.last) then
            do return (nil) end
        end
        else
            if (i < self.last) then
            do return (nil) end
        end
        end
        do return i end
        end
        do return rangex5Fmt[key] end
    end); __len = (function(self)
        local len;
        len = (self.last - self.first) / self.step + 1;
        if (len < 0) then
            len = 0;
        end
        do return len:rounded_down() end
    end); __eq = (function(self, other)
        return ((getmetatable(self) == getmetatable(other)) and ((self.first == other.first) and ((self.last == other.last) and (self.step == other.step))))
    end); backwards = (function(self)
        return _1_to_2_by(self.last, self.first, (-(self.step)))
    end); __inext = inext; __next = inext; as_text = (function(self)
        if (self.step == 1) then
            do return Text("(", self.first, " to ", self.last, ")") end
        else
            do return Text("(", self.first, " to ", self.last, " by ", self.step, ")") end
        end
    end);
};
rangex5Fmt.reversed = rangex5Fmt.backwards;
rangex5Fmt.__unm = rangex5Fmt.backwards;
rangex5Fmt.__tostring = rangex5Fmt.as_text;
rangex5Fmt.as_nomsu = rangex5Fmt.as_text;
setmetatable(rangex5Fmt, (nil));
_1_to_2_by = (function(first, last, step)
    return setmetatable(a_Dict{first = first; last = last; step = step;}, rangex5Fmt)
end);
_1_to = (function(first, last)
    return setmetatable(a_Dict{first = first; last = last; step = 1;}, rangex5Fmt)
end);
