#!/usr/bin/env nomsu -V7.0.0-- File lib/core/control_flow.nom chunk #1
-- 
-- This file contains compile-time actions that define basic control flow structures
-- like "if" statements and loops.
-- ;
_ENV:use("core/metaprogramming");
_ENV:use("core/operators");

-- File lib/core/control_flow.nom chunk #2
--  No-Op;
TESTS["@lib/core/control_flow.nom[306:322]"] = "\ndo nothing";
COMPILE_RULES["do nothing"] = (function(_ENV, _tree)
    return LuaCode:from("@lib/core/control_flow.nom[348:350]")
end);
--  Conditionals;
TESTS["@lib/core/control_flow.nom[373:419]"] = "\nif (no):\n    fail \"conditional fail\"";
COMPILE_RULES["if"] = (function(_ENV, _tree, condition, ifx5Fbody)
    return LuaCode:from("@lib/core/control_flow.nom[458:536]", "",
        LuaCode:from("@lib/core/control_flow.nom[465:468]", "if "),
        _ENV:_1_as_lua_expr(condition),
        LuaCode:from("@lib/core/control_flow.nom[493:503]", " then\n"),
        LuaCode:from("@lib/core/control_flow.nom[503:507]", "    "),
        _ENV:compile(ifx5Fbody), "\n",
        LuaCode:from("@lib/core/control_flow.nom[530:533]", "end"))
end);
TESTS["@lib/core/control_flow.nom[542:593]"] = "\nunless (yes):\n    fail \"conditional fail\"";
COMPILE_RULES["unless"] = (function(_ENV, _tree, condition, unlessx5Fbody)
    local mangle = mangler()
    return SyntaxTree{"if", SyntaxTree{"not", condition, type= "Action", source= "@lib/core/control_flow.nom[643:657]", stub= "not"}, unlessx5Fbody, type= "Action", source= "@lib/core/control_flow.nom[639:671]", stub= "if"}
end);
COMPILE_RULES["if 1 2 else"] = (function(_ENV, _tree, condition, ifx5Fbody, elsex5Fbody)
    return LuaCode:from("@lib/core/control_flow.nom[779:895]", "",
        LuaCode:from("@lib/core/control_flow.nom[786:789]", "if "),
        _ENV:_1_as_lua_expr(condition),
        LuaCode:from("@lib/core/control_flow.nom[814:824]", " then\n"),
        LuaCode:from("@lib/core/control_flow.nom[824:828]", "    "),
        _ENV:compile(ifx5Fbody), "\n",
        LuaCode:from("@lib/core/control_flow.nom[851:860]", "else\n"),
        LuaCode:from("@lib/core/control_flow.nom[860:864]", "    "),
        _ENV:compile(elsex5Fbody), "\n",
        LuaCode:from("@lib/core/control_flow.nom[889:892]", "end"))
end)
COMPILE_RULES["unless 1 2 else"] = function(_ENV, _tree, condition, elsex5Fbody, ifx5Fbody) return COMPILE_RULES["if 1 2 else"](_ENV, _tree, condition, ifx5Fbody, elsex5Fbody) end
COMPILE_RULES["else"] = (function(_ENV, _tree, _)
    at_1_fail(_tree,
        Text("Compile error: This 'else' is not connected to any 'if' or 'unless' condition.\n",
          "Hint: You should probably have a \"..\" in front of the \"else\", to indicate that it's attached to the previous condition."));
end);

-- File lib/core/control_flow.nom chunk #3
--  Conditional expression (ternary operator);
--    Note: this uses a function instead of "(condition and if_expr or else_expr)"
-- because that breaks if $if_expr is falsey, e.g. "x < 5 and false or 99";
TESTS["@lib/core/control_flow.nom[1472:1548]"] = "\nassume ((1 if (yes) else 2) == 1)\nassume ((1 if (no) else 2) == 2)";
COMPILE_RULES["1 if 2 else"] = (function(_ENV, _tree, whenx5Ftruex5Fexpr, condition, whenx5Ffalsex5Fexpr)
    --    If $when_true_expr is guaranteed to be truthy, we can use Lua's idiomatic
    -- equivalent of a conditional expression: (cond and if_true or if_false);
    if (a_Dict{Text=true, List=true, Dict=true, Number=true})[whenx5Ftruex5Fexpr.type] then
        do return LuaCode:from("@lib/core/control_flow.nom[2051:2190]", "",
        LuaCode:from("@lib/core/control_flow.nom[2066:2067]", "("),
        _ENV:_1_as_lua_expr(condition),
        LuaCode:from("@lib/core/control_flow.nom[2092:2097]", " and "),
        _ENV:_1_as_lua_expr(whenx5Ftruex5Fexpr),
        LuaCode:from("@lib/core/control_flow.nom[2127:2147]", " or "),
        _ENV:_1_as_lua_expr(whenx5Ffalsex5Fexpr),
        LuaCode:from("@lib/core/control_flow.nom[2178:2179]", ")")) end
    else
        --    Otherwise, need to do an anonymous inline function (yuck, too bad lua 
    -- doesn't have a proper ternary operator!)
    -- To see why this is necessary consider: (random()<.5 and false or 99);
    do return LuaCode:from("@lib/core/control_flow.nom[2441:2707]", "",
        LuaCode:from("@lib/core/control_flow.nom[2456:2481]", "((function()\n"),
        LuaCode:from("@lib/core/control_flow.nom[2481:2488]", "    if "),
        _ENV:_1_as_lua_expr(condition),
        LuaCode:from("@lib/core/control_flow.nom[2513:2531]", " then\n"),
        LuaCode:from("@lib/core/control_flow.nom[2531:2546]", "        return "),
        _ENV:_1_as_lua_expr(whenx5Ftruex5Fexpr), "\n",
        LuaCode:from("@lib/core/control_flow.nom[2589:2610]", "    else\n"),
        LuaCode:from("@lib/core/control_flow.nom[2610:2625]", "        return "),
        _ENV:_1_as_lua_expr(whenx5Ffalsex5Fexpr), "\n",
        LuaCode:from("@lib/core/control_flow.nom[2669:2689]", "    end\n"),
        LuaCode:from("@lib/core/control_flow.nom[2689:2696]", "end)())")) end
    end
end)
COMPILE_RULES["1 if 2 otherwise"] = COMPILE_RULES["1 if 2 else"]
COMPILE_RULES["1 unless 2 else"] = function(_ENV, _tree, whenx5Ffalsex5Fexpr, condition, whenx5Ftruex5Fexpr) return COMPILE_RULES["1 if 2 else"](_ENV, _tree, whenx5Ftruex5Fexpr, condition, whenx5Ffalsex5Fexpr) end
COMPILE_RULES["1 unless 2 then"] = function(_ENV, _tree, whenx5Ffalsex5Fexpr, condition, whenx5Ftruex5Fexpr) return COMPILE_RULES["1 if 2 else"](_ENV, _tree, whenx5Ftruex5Fexpr, condition, whenx5Ffalsex5Fexpr) end

-- File lib/core/control_flow.nom chunk #4
--  GOTOs;
TESTS["@lib/core/control_flow.nom[2805:3007]"] = "\n$i = 0\n--- $loop ---\n$i += 1\nunless ($i == 10):\n    go to $loop\nassume ($i == 10)\n--- (Loop) ---\n$i -= 1\nunless ($i == 0):\n    go to (Loop)\nassume ($i == 0)";
COMPILE_RULES["--- 1 ---"] = (function(_ENV, _tree, label)
    return LuaCode:from("@lib/core/control_flow.nom[3038:3170]", "",
        LuaCode:from("@lib/core/control_flow.nom[3045:3053]", "::label_"),
        ((function()
            if (label.type == "Action") then
                return label.stub:as_lua_id()
            else
                return _1_as_lua_identifier(label)
            end
        end)()), LuaCode:from("@lib/core/control_flow.nom[3165:3167]", "::"))
end);
COMPILE_RULES["go to"] = (function(_ENV, _tree, label)
    return LuaCode:from("@lib/core/control_flow.nom[3199:3332]", "",
        LuaCode:from("@lib/core/control_flow.nom[3206:3217]", "goto label_"),
        ((function()
            if (label.type == "Action") then
                return label.stub:as_lua_id()
            else
                return _1_as_lua_identifier(label)
            end
        end)()))
end);
--  Basic loop control;
COMPILE_RULES["stop"] = (function(_ENV, _tree, var)
    if var then
        do return LuaCode:from("@lib/core/control_flow.nom[3414:3451]", "goto stop_",
        _1_as_lua_identifier(var)) end
    else
        do return LuaCode:from("@lib/core/control_flow.nom[3483:3490]", "break") end
    end
end);
COMPILE_RULES["do next"] = (function(_ENV, _tree, var)
    if var then
        do return LuaCode:from("@lib/core/control_flow.nom[3552:3593]", "goto continue_",
        _1_as_lua_identifier(var)) end
    else
        do return LuaCode:from("@lib/core/control_flow.nom[3625:3640]", "goto continue") end
    end
end);
COMPILE_RULES["--- stop 1 ---"] = (function(_ENV, _tree, var)
    return LuaCode:from("@lib/core/control_flow.nom[3673:3709]", "::stop_",
        _1_as_lua_identifier(var), "::")
end);
COMPILE_RULES["--- next 1 ---"] = (function(_ENV, _tree, var)
    return LuaCode:from("@lib/core/control_flow.nom[3741:3781]", "::continue_",
        _1_as_lua_identifier(var), "::")
end);
--  While loops;
TESTS["@lib/core/control_flow.nom[3803:4067]"] = "\n$x = 0\nrepeat while ($x < 10): $x += 1\nassume ($x == 10)\nrepeat while ($x < 20): stop\nassume ($x == 10)\nrepeat while ($x < 20):\n    $x += 1\n    if (yes):\n        do next\n    fail \"Failed to 'do next'\"\nassume ($x == 20)";
COMPILE_RULES["repeat while"] = (function(_ENV, _tree, condition, body)
    local lua;
    lua = LuaCode:from("@lib/core/control_flow.nom[4137:4229]", "",
        LuaCode:from("@lib/core/control_flow.nom[4152:4158]", "while "),
        _ENV:_1_as_lua_expr(condition),
        LuaCode:from("@lib/core/control_flow.nom[4183:4199]", " do\n"),
        LuaCode:from("@lib/core/control_flow.nom[4199:4203]", "    "),
        _ENV:compile(body));
    if body:contains(
        SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 4261, 4268), "do", "next"}) then
        lua:add("\n    ::continue::");
    end
    lua:add("\nend --while-loop");
    do return lua end
end);
COMPILE_RULES["repeat"] = (function(_ENV, _tree, body)
    local mangle = mangler()
    return SyntaxTree{"repeat", "while", SyntaxTree{"yes", type= "Action", source= "@lib/core/control_flow.nom[4408:4411]", stub= "yes"}, body, type= "Action", source= "@lib/core/control_flow.nom[4394:4418]", stub= "repeat while"}
end);
COMPILE_RULES["repeat until"] = (function(_ENV, _tree, condition, body)
    local mangle = mangler()
    return SyntaxTree{"repeat", "while", SyntaxTree{"not", condition, type= "Action", source= "@lib/core/control_flow.nom[4477:4491]", stub= "not"}, body, type= "Action", source= "@lib/core/control_flow.nom[4463:4498]", stub= "repeat while"}
end);

-- File lib/core/control_flow.nom chunk #5
--  For-each loop (lua's "ipairs()");
COMPILE_RULES["for 1 in"] = (function(_ENV, _tree, var, iterable, body)
    local key, value, start, stop, loop, step, lua;
    if (not var) then
        at_1_fail(_tree, "No var here");
    end
    --  This uses Lua's approach of only allowing loop-scoped variables in a loop;
    if ((var.type == "Action") and (var.stub == "1 =")) then
        key, value = var[1], var[3];
    else
        key, value = (nil), var;
    end
    if (not value) then
        at_1_fail(_tree, "No value here");
    end
    --  Numeric loop:;
    if ((iterable.type == "Action") and (iterable:get_stub() == "1 to")) then
        start, stop = iterable[1], iterable[3];
    loop = LuaCode:from("@lib/core/control_flow.nom[5216:5365]", "",
        LuaCode:from("@lib/core/control_flow.nom[5235:5250]", "local _start = "),
        _ENV:_1_as_lua_expr(start), "\n",
        LuaCode:from("@lib/core/control_flow.nom[5288:5292]", "for "),
        _1_as_lua_identifier(value),
        LuaCode:from("@lib/core/control_flow.nom[5319:5327]", "=_start,"),
        _ENV:_1_as_lua_expr(stop),
        LuaCode:from("@lib/core/control_flow.nom[5347:5350]", " do"));
    if key then
        loop:add(
        Text("\n", "    local ", _1_as_lua_identifier(key), " = ",
          _1_as_lua_identifier(value), " - _start + 1;"));
    end
    goto label_loop_set;
    end
    --  Numeric loop with step:;
    if ((iterable.type == "Action") and (iterable:get_stub() == "1 to 2 by")) then
        start, stop, step = iterable[1], iterable[3], iterable[5];
    loop = LuaCode:from("@lib/core/control_flow.nom[5804:5989]", "",
        LuaCode:from("@lib/core/control_flow.nom[5823:5845]", "local _start, _step = "),
        _ENV:_1_as_lua_expr(start),
        LuaCode:from("@lib/core/control_flow.nom[5866:5868]", ", "),
        _ENV:_1_as_lua_expr(step),
        LuaCode:from("@lib/core/control_flow.nom[5888:5906]", ";\n"),
        LuaCode:from("@lib/core/control_flow.nom[5906:5910]", "for "),
        _1_as_lua_identifier(value),
        LuaCode:from("@lib/core/control_flow.nom[5937:5945]", "=_start,"),
        _ENV:_1_as_lua_expr(stop),
        LuaCode:from("@lib/core/control_flow.nom[5965:5974]", ",_step do"));
    if key then
        loop:add(
        Text("\n", "    local ", _1_as_lua_identifier(key), " = (",
          _1_as_lua_identifier(value), " - _start)/_step + 1"));
    end
    goto label_loop_set;
    end
    --  for $ in (...):;
    if key then
        loop = LuaCode:from("@lib/core/control_flow.nom[6285:6434]", "",
        LuaCode:from("@lib/core/control_flow.nom[6304:6308]", "for "),
        _1_as_lua_identifier(key),
        LuaCode:from("@lib/core/control_flow.nom[6333:6334]", ","),
        _1_as_lua_identifier(value),
        LuaCode:from("@lib/core/control_flow.nom[6361:6391]", " in pairs("),
        _ENV:_1_as_lua_expr(iterable),
        LuaCode:from("@lib/core/control_flow.nom[6415:6419]", ") do"));
    else
        loop = LuaCode:from("@lib/core/control_flow.nom[6479:6555]", "for _i,",
        _1_as_lua_identifier(value), " in _ipairs(", _ENV:_1_as_lua_expr(iterable),
        ") do");
    end
    ::label_loop_set::;
    --  TODO: don't always wrap in block;
    lua = LuaCode:from("@lib/core/control_flow.nom[6653:6739]", "",
        LuaCode:from("@lib/core/control_flow.nom[6668:6695]", "do -- for-loop\n"),
        LuaCode:from("@lib/core/control_flow.nom[6695:6699]", "    "), loop, "\n",
        LuaCode:from("@lib/core/control_flow.nom[6718:6728]", "        "));
    lua:add(_ENV:compile(body));
    if body:contains(
        SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 6795, 6802), "do", "next"}) then
        lua:add("\n        ::continue::");
    end
    if (key and body:contains(
        SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 6890, 6903), "do", "next", key})) then
        lua:add("\n        ",
        _ENV:compile(SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 6942, 6959), "---", "next", key, "---"}));
    end
    if body:contains(
        SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 7000, 7015), "do", "next", value}) then
        lua:add("\n        ",
        _ENV:compile(SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 7053, 7072), "---", "next", value, "---"}));
    end
    lua:add("\n    end");
    if (key and body:contains(
        SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 7149, 7159), "stop", key})) then
        lua:add("\n    ",
        _ENV:compile(SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 7194, 7211), "---", "stop", key, "---"}));
    end
    if body:contains(
        SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 7252, 7264), "stop", value}) then
        lua:add("\n    ",
        _ENV:compile(SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 7298, 7317), "---", "stop", value, "---"}));
    end
    lua:add("\nend -- for-loop");
    lua:remove_free_vars(
        a_List{(_1_as_lua_identifier(value)):text(), (key and (_1_as_lua_identifier(key)):text())});
    do return lua end
end);
TESTS["@lib/core/control_flow.nom[7498:7804]"] = "\n$d = {.a = 10, .b = 20, .c = 30, .d = 40, .e = 50}\n$result = []\nfor ($k = $v) in $d:\n    if ($k == \"a\"):\n        do next $k\n    \n    if ($v == 20):\n        do next $v\n    \n    $result, add \"\\$k = \\$v\"\nassume (($result sorted) == [\"c = 30\", \"d = 40\", \"e = 50\"])";
--  Numeric range for loops;
TESTS["@lib/core/control_flow.nom[7838:8337]"] = "\nassume ([: for $ in (1 to 5): add $] == [1, 2, 3, 4, 5])\nassume ([: for $ in (1 to 5 by 2): add $] == [1, 3, 5])\nassume ([: for $ in (5 to 1): add $] == [])\n$nums = []\nfor $outer in (1 to 100):\n    for $inner in ($outer to ($outer + 2)):\n        if ($inner == 2):\n            $nums, add -2\n            do next $inner\n        $nums, add $inner\n        if ($inner == 5):\n            stop $outer\n\nassume ($nums == [1, -2, 3, -2, 3, 4, 3, 4, 5])";
--  repeat $n times is a shorthand:;
TESTS["@lib/core/control_flow.nom[8379:8446]"] = "\n$x = 0\nrepeat 5 times:\n    $x += 1\nassume $x == 5";
COMPILE_RULES["repeat 1 times"] = (function(_ENV, _tree, n, body)
    local mangle = mangler()
    return SyntaxTree{"for", SyntaxTree{"=", "lua", SyntaxTree{"_i", type= "Text", source= "@lib/core/control_flow.nom[8492:8496]"}, type= "Action", source= "@lib/core/control_flow.nom[8487:8496]", stub= "= lua"}, "in", SyntaxTree{SyntaxTree{"1", type= "Number", source= "@lib/core/control_flow.nom[8502:8503]"}, "to", n, "by", SyntaxTree{"1", type= "Number", source= "@lib/core/control_flow.nom[8513:8514]"}, type= "Action", source= "@lib/core/control_flow.nom[8502:8514]", stub= "1 to 2 by"}, body, type= "Action", source= "@lib/core/control_flow.nom[8482:8521]", stub= "for 1 in"}
end);

-- File lib/core/control_flow.nom chunk #6
TESTS["@lib/core/control_flow.nom[8610:8913]"] = "\nwhen:\n    (1 == 2) (100 < 0):\n        fail \"bad conditional\"\n    (1 == 0) (1 == 1) $not_a_variable.x: do nothing\n    (1 == 1):\n        fail \"bad conditional\"\n    \n    (1 == 2):\n        fail \"bad conditional\"\n    \n    else:\n        fail \"bad conditional\"";
--  Multi-branch conditional (if..elseif..else);
COMPILE_RULES["when"] = (function(_ENV, _tree, body)
    local code, clause, elsex5Fallowed, action;
    code = LuaCode:from("@lib/core/control_flow.nom[9006:9008]");
    clause = "if";
    elsex5Fallowed = (true);
    if (not (body.type == "Block")) then
        at_1_fail(body,
        Text("Compile error: 'if' expected a Block, but got a ", body.type, ".\n",
          "Hint: Perhaps you forgot to put a ':' after 'if'?"));
    end
    do -- for-loop
        for _i,line in _ipairs(body) do
            if (not (((line.type == "Action") and ((#line) >= 2)) and _1_is_2_syntax_tree(line[(#line)], "Block"))) then
        at_1_fail(line,
        Text("Compile error: Invalid line for the body of an 'if' block.\n",
          "Hint: Each line should contain one or more conditional expressions followed by a block, or \"else\" followed by a block."));
    end
    action = line[(#line)];
    if ((line[1] == "else") and ((#line) == 2)) then
        if (not elsex5Fallowed) then
        at_1_fail(line,
        Text("Compile error: You can't have two 'else' blocks.\n",
          "Hint: Merge all of the 'else' blocks together."));
    end
    if (not ((#Text(code)) > 0)) then
        at_1_fail(line,
        Text("Compile error: You can't have an 'else' block without a preceding condition.\n",
          "Hint: If you want the code in this block to always execute, you don't need a conditional block around it. Otherwise, make sure the 'else' block comes last."));
    end
    code:add("\nelse\n    ", _ENV:compile(action));
    elsex5Fallowed = (false);
    else
        code:add(clause, " ");
    do -- for-loop
        local _start = 1
    for i=_start,((#line)) - 1 do
            if (i > 1) then
        code:add(" or ");
    end
    code:add(_ENV:_1_as_lua_expr(line[i]));
        end
    end -- for-loop;
    code:add(" then\n    ", _ENV:compile(action));
    clause = "\nelseif";
    end
        end
    end -- for-loop;
    if ((#Text(code)) == 0) then
        at_1_fail(body,
        Text("Compile error: 'if' block has an empty body.\n",
          "Hint: This means nothing would happen, so the 'if' block should be deleted."));
    end
    code:add("\nend --when");
    do return code end
end);
TESTS["@lib/core/control_flow.nom[11081:11320]"] = "\nif 5 is:\n    1 2 3:\n        fail \"bad switch statement\"\n    \n    4 5:\n        do nothing\n    \n    5 6:\n        fail \"bad switch statement\"\n    \n    else:\n        fail \"bad switch statement\"";
--  Switch statement;
COMPILE_RULES["if 1 is"] = (function(_ENV, _tree, branchx5Fvalue, body)
    local code, clause, elsex5Fallowed, action;
    code = LuaCode:from("@lib/core/control_flow.nom[11433:11435]");
    clause = "if";
    elsex5Fallowed = (true);
    local mangle = mangler();
    if (not (body.type == "Block")) then
        at_1_fail(body,
        Text("Compile error: 'if' expected a Block, but got a ", body.type, ".\n",
          "Hint: Perhaps you forgot to put a ':' after the 'is'?"));
    end
    do -- for-loop
        for _i,line in _ipairs(body) do
            if (not (((line.type == "Action") and ((#line) >= 2)) and _1_is_2_syntax_tree(line[(#line)], "Block"))) then
        at_1_fail(line,
        Text("Compile error: Invalid line for 'if' block.\n",
          "Hint: Each line should contain expressions followed by a block, or \"else\" followed by a block."));
    end
    action = line[(#line)];
    if ((line[1] == "else") and ((#line) == 2)) then
        if (not elsex5Fallowed) then
        at_1_fail(line,
        Text("Compile error: You can't have two 'else' blocks.\n",
          "Hint: Merge all of the 'else' blocks together."));
    end
    if (not ((#Text(code)) > 0)) then
        at_1_fail(line,
        Text("Compile error: You can't have an 'else' block without a preceding condition.\n",
          "Hint: If you want the code in this block to always execute, you don't need a conditional block around it. Otherwise, make sure the 'else' block comes last."));
    end
    code:add("\nelse\n    ", _ENV:compile(action));
    elsex5Fallowed = (false);
    else
        code:add(clause, " ");
    do -- for-loop
        local _start = 1
    for i=_start,((#line)) - 1 do
            if (i > 1) then
        code:add(" or ");
    end
    code:add(Text(mangle("branch value"), " == "), _ENV:_1_as_lua_expr(line[i]));
        end
    end -- for-loop;
    code:add(" then\n    ", _ENV:compile(action));
    clause = "\nelseif";
    end
        end
    end -- for-loop;
    if ((#Text(code)) == 0) then
        at_1_fail(body,
        Text("Compile error: 'if' block has an empty body.\n",
          "Hint: This means nothing would happen, so the 'if' block should be deleted."));
    end
    code:add("\nend --when");
    do return LuaCode:from("@lib/core/control_flow.nom[13496:13648]", "",
        LuaCode:from("@lib/core/control_flow.nom[13507:13531]", "do --if $ is...\n"),
        LuaCode:from("@lib/core/control_flow.nom[13531:13541]", "    local "),
        mangle("branch value"),
        LuaCode:from("@lib/core/control_flow.nom[13565:13568]", " = "),
        _ENV:_1_as_lua_expr(branchx5Fvalue), "\n",
        LuaCode:from("@lib/core/control_flow.nom[13605:13609]", "    "), code, "\n",
        LuaCode:from("@lib/core/control_flow.nom[13624:13641]", "end -- if $ is...")) end
end)
COMPILE_RULES["when 1 is"] = COMPILE_RULES["if 1 is"];
--  Do/finally;
COMPILE_RULES["do"] = (function(_ENV, _tree, action)
    return LuaCode:from("@lib/core/control_flow.nom[13690:13742]", "",
        LuaCode:from("@lib/core/control_flow.nom[13697:13704]", "do\n"),
        LuaCode:from("@lib/core/control_flow.nom[13704:13708]", "    "),
        _ENV:compile(action), "\n",
        LuaCode:from("@lib/core/control_flow.nom[13730:13739]", "end -- do"))
end);
TESTS["@lib/core/control_flow.nom[13748:13791]"] = "\nassume ((result of: return 99) == 99)";
--  Inline thunk:;
COMPILE_RULES["result of"] = (function(_ENV, _tree, body)
    return LuaCode:from("@lib/core/control_flow.nom[13841:13868]",
        _ENV:compile(SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 13846, 13856), "->", body}),
        "()")
end);
TESTS["@lib/core/control_flow.nom[13873:14148]"] = "\n$t = [1, [2, [[3], 4], 5, [[[6]]]]]\n$flat = []\nfor $ in recursive $t:\n    if ((lua type of $) == \"table\"):\n        for $2 in $:\n            recurse $ on $2\n    ..else:\n        $flat, add $\n\nassume (sorted $flat) == [1, 2, 3, 4, 5, 6]";
--  Recurion control flow;
COMPILE_RULES["recurse 1 on"] = (function(_ENV, _tree, v, x)
    return LuaCode:from("@lib/core/control_flow.nom[14215:14274]", "table.insert(_stack_",
        _ENV:_1_as_lua_expr(v), ", ", _ENV:_1_as_lua_expr(x), ")")
end);
COMPILE_RULES["for 1 in recursive"] = (function(_ENV, _tree, var, structure, body)
    local lua;
    lua = LuaCode:from("@lib/core/control_flow.nom[14353:14645]", "",
        LuaCode:from("@lib/core/control_flow.nom[14368:14383]", "do\n"),
        LuaCode:from("@lib/core/control_flow.nom[14383:14400]", "    local _stack_"),
        _ENV:_1_as_lua_expr(var),
        LuaCode:from("@lib/core/control_flow.nom[14419:14429]", " = a_List{"),
        _ENV:_1_as_lua_expr(structure),
        LuaCode:from("@lib/core/control_flow.nom[14454:14468]", "}\n"),
        LuaCode:from("@lib/core/control_flow.nom[14468:14486]", "    while #_stack_"),
        _ENV:_1_as_lua_expr(var),
        LuaCode:from("@lib/core/control_flow.nom[14505:14525]", " > 0 do\n"),
        LuaCode:from("@lib/core/control_flow.nom[14525:14533]", "        "),
        _ENV:_1_as_lua_expr(var),
        LuaCode:from("@lib/core/control_flow.nom[14552:14575]", " = table.remove(_stack_"),
        _ENV:_1_as_lua_expr(var),
        LuaCode:from("@lib/core/control_flow.nom[14594:14611]", ", 1)\n"),
        LuaCode:from("@lib/core/control_flow.nom[14611:14619]", "        "),
        _ENV:compile(body));
    if body:contains(
        SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 14677, 14684), "do", "next"}) then
        lua:add("\n        ::continue::");
    end
    if body:contains(
        SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 14762, 14775), "do", "next", var}) then
        lua:add(
        Text("\n        ",
          _ENV:compile(SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 14812, 14829), "---", "next", var, "---"})));
    end
    lua:add("\n    end -- Recursive loop");
    if body:contains(
        SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 14915, 14925), "stop", var}) then
        lua:add(
        Text("\n        ",
          _ENV:compile(SyntaxTree{type="Action", source=Source("lib/core/control_flow.nom", 14962, 14979), "---", "stop", var, "---"})));
    end
    lua:add("\nend -- Recursive scope");
    do return lua end
end);
