#!/usr/bin/env nomsu -V7.0.0-- File lib/core/errors.nom chunk #1
-- 
-- This file contains basic error reporting code
-- ;
_ENV:use("core/metaprogramming");
_ENV:use("core/operators");
_ENV:use("core/control_flow");

-- File lib/core/errors.nom chunk #2
COMPILE_RULES["fail"] = (function(_ENV, _tree, msg)
    return LuaCode:from("@lib/core/errors.nom[268:405]", "",
        LuaCode:from("@lib/core/errors.nom[275:285]", "at_1_fail("),
        quote(_tree.source), LuaCode:from("@lib/core/errors.nom[312:318]", ",\n"),
        LuaCode:from("@lib/core/errors.nom[318:322]", "    "), ((function()
            if msg then
                return _ENV:_1_as_lua_expr(msg)
            else
                return quote("A failure was triggered here'")
            end
        end)()), "\n", LuaCode:from("@lib/core/errors.nom[401:402]", ")"))
end);
COMPILE_RULES["assume"] = (function(_ENV, _tree, condition)
    if (condition.type == "IndexChain") then
        do return LuaCode:from("@lib/core/errors.nom[501:984]", "",
        LuaCode:from("@lib/core/errors.nom[516:546]", "do -- Assumption:\n"),
        LuaCode:from("@lib/core/errors.nom[546:571]", "    local _thing, _key = "),
        _ENV:_1_as_lua_expr(condition[1]),
        LuaCode:from("@lib/core/errors.nom[598:600]", ", "),
        _ENV:_1_as_lua_expr(condition[2][1]), "\n",
        LuaCode:from("@lib/core/errors.nom[642:683]", "    if not _thing[_key] then\n"),
        LuaCode:from("@lib/core/errors.nom[683:772]",
            "        _key = type_of(_key) == 'Text' and _key:as_lua() or _1_as_text(_key)\n"),
        LuaCode:from("@lib/core/errors.nom[772:790]", "        at_1_fail("),
        quote(Text(condition.source)),
        LuaCode:from("@lib/core/errors.nom[821:835]", ",\n"),
        LuaCode:from("@lib/core/errors.nom[835:867]", "            \"Assumption failed: "),
        (_1_as_nomsu(condition[1])):text(),
        LuaCode:from("@lib/core/errors.nom[897:950]",
            " does not have a value for \".._key..\".\")\n"),
        LuaCode:from("@lib/core/errors.nom[950:970]", "    end\n"),
        LuaCode:from("@lib/core/errors.nom[970:973]", "end")) end
    end
    if (condition.type == "Action") then
        do --if $ is...
        local branch_valuex031B = condition.stub
        if branch_valuex031B == "1 ==" then
        do return LuaCode:from("@lib/core/errors.nom[1108:1721]", "",
            LuaCode:from("@lib/core/errors.nom[1131:1169]", "do -- Assumption:\n"),
            LuaCode:from("@lib/core/errors.nom[1169:1188]", "    local _a, _b = "),
            _ENV:_1_as_lua_expr(condition[1]),
            LuaCode:from("@lib/core/errors.nom[1215:1217]", ", "),
            _ENV:_1_as_lua_expr(condition[3]), "\n",
            LuaCode:from("@lib/core/errors.nom[1265:1306]", "    if _a ~= _b then\n"),
            LuaCode:from("@lib/core/errors.nom[1306:1395]",
                "        _a = type_of(_a) == 'Text' and _a:as_lua() or _1_as_text(_a)\n"),
            LuaCode:from("@lib/core/errors.nom[1395:1484]",
                "        _b = type_of(_b) == 'Text' and _b:as_lua() or _1_as_text(_b)\n"),
            LuaCode:from("@lib/core/errors.nom[1484:1502]", "        at_1_fail("),
            quote(Text(condition[1].source)),
            LuaCode:from("@lib/core/errors.nom[1535:1557]", ",\n"),
            LuaCode:from("@lib/core/errors.nom[1557:1671]",
                "            \"Assumption failed: This value was \".._a..\" but it was expected to be \".._b..\".\")\n"),
            LuaCode:from("@lib/core/errors.nom[1671:1699]", "    end\n"),
            LuaCode:from("@lib/core/errors.nom[1699:1702]", "end")) end
    elseif branch_valuex031B == "1 !=" then
        do return LuaCode:from("@lib/core/errors.nom[1782:2300]", "",
            LuaCode:from("@lib/core/errors.nom[1805:1843]", "do -- Assumption:\n"),
            LuaCode:from("@lib/core/errors.nom[1843:1862]", "    local _a, _b = "),
            _ENV:_1_as_lua_expr(condition[1]),
            LuaCode:from("@lib/core/errors.nom[1889:1891]", ", "),
            _ENV:_1_as_lua_expr(condition[3]), "\n",
            LuaCode:from("@lib/core/errors.nom[1939:1980]", "    if _a == _b then\n"),
            LuaCode:from("@lib/core/errors.nom[1980:2069]",
                "        _a = type_of(_a) == 'Text' and _a:as_lua() or _1_as_text(_a)\n"),
            LuaCode:from("@lib/core/errors.nom[2069:2087]", "        at_1_fail("),
            quote(Text(condition[1].source)),
            LuaCode:from("@lib/core/errors.nom[2120:2142]", ",\n"),
            LuaCode:from("@lib/core/errors.nom[2142:2250]",
                "            \"Assumption failed: This value was \".._a..\" but it wasn't expected to be.\")\n"),
            LuaCode:from("@lib/core/errors.nom[2250:2278]", "    end\n"),
            LuaCode:from("@lib/core/errors.nom[2278:2281]", "end")) end
    elseif branch_valuex031B == "1 >" or branch_valuex031B == "1 <" or branch_valuex031B == "1 >=" or branch_valuex031B == "1 <=" then
        do return LuaCode:from("@lib/core/errors.nom[2380:3052]", "",
            LuaCode:from("@lib/core/errors.nom[2403:2441]", "do -- Assumption:\n"),
            LuaCode:from("@lib/core/errors.nom[2441:2460]", "    local _a, _b = "),
            _ENV:_1_as_lua_expr(condition[1]),
            LuaCode:from("@lib/core/errors.nom[2487:2489]", ", "),
            _ENV:_1_as_lua_expr(condition[3]), "\n",
            LuaCode:from("@lib/core/errors.nom[2537:2552]", "    if not (_a "),
            condition[2], LuaCode:from("@lib/core/errors.nom[2567:2597]", " _b) then\n"),
            LuaCode:from("@lib/core/errors.nom[2597:2686]",
                "        _a = type_of(_a) == 'Text' and _a:as_lua() or _1_as_text(_a)\n"),
            LuaCode:from("@lib/core/errors.nom[2686:2775]",
                "        _b = type_of(_b) == 'Text' and _b:as_lua() or _1_as_text(_b)\n"),
            LuaCode:from("@lib/core/errors.nom[2775:2793]", "        at_1_fail("),
            quote(Text(condition[1].source)),
            LuaCode:from("@lib/core/errors.nom[2826:2848]", ",\n"),
            LuaCode:from("@lib/core/errors.nom[2848:2955]",
                "            \"Assumption failed: This value was \".._a..\", but it was expected to be "),
            condition[2],
            LuaCode:from("@lib/core/errors.nom[2970:3002]", "\".._b..\".\")\n"),
            LuaCode:from("@lib/core/errors.nom[3002:3030]", "    end\n"),
            LuaCode:from("@lib/core/errors.nom[3030:3033]", "end")) end
    elseif branch_valuex031B == "1 is" then
        do return LuaCode:from("@lib/core/errors.nom[3113:3649]", "",
            LuaCode:from("@lib/core/errors.nom[3136:3174]", "do -- Assumption:\n"),
            LuaCode:from("@lib/core/errors.nom[3174:3193]", "    local _a, _b = "),
            _ENV:_1_as_lua_expr(condition[1]),
            LuaCode:from("@lib/core/errors.nom[3220:3222]", ", "),
            _ENV:_1_as_lua_expr(condition[3]), "\n",
            LuaCode:from("@lib/core/errors.nom[3270:3320]", "    if not _1_is(_a, _b) then\n"),
            LuaCode:from("@lib/core/errors.nom[3320:3409]",
                "        _a = type_of(_a) == 'Text' and _a:as_lua() or _1_as_text(_a)\n"),
            LuaCode:from("@lib/core/errors.nom[3409:3427]", "        at_1_fail("),
            quote(Text(condition[1].source)),
            LuaCode:from("@lib/core/errors.nom[3460:3482]", ",\n"),
            LuaCode:from("@lib/core/errors.nom[3482:3599]",
                "            \"Assumption failed: This value (\".._a..\") was expected to be \".._b..\", but wasn't.\")\n"),
            LuaCode:from("@lib/core/errors.nom[3599:3627]", "    end\n"),
            LuaCode:from("@lib/core/errors.nom[3627:3630]", "end")) end
    elseif branch_valuex031B == "1 isn ' t" or branch_valuex031B == "1 is not" then
        do return LuaCode:from("@lib/core/errors.nom[3726:4274]", "",
            LuaCode:from("@lib/core/errors.nom[3749:3787]", "do -- Assumption:\n"),
            LuaCode:from("@lib/core/errors.nom[3787:3806]", "    local _a, _b = "),
            _ENV:_1_as_lua_expr(condition[1]),
            LuaCode:from("@lib/core/errors.nom[3833:3835]", ", "),
            _ENV:_1_as_lua_expr(condition[(#condition)]), "\n",
            LuaCode:from("@lib/core/errors.nom[3895:3941]", "    if _1_is(_a, _b) then\n"),
            LuaCode:from("@lib/core/errors.nom[3941:4030]",
                "        _a = type_of(_a) == 'Text' and _a:as_lua() or _1_as_text(_a)\n"),
            LuaCode:from("@lib/core/errors.nom[4030:4048]", "        at_1_fail("),
            quote(Text(condition[1].source)),
            LuaCode:from("@lib/core/errors.nom[4081:4103]", ",\n"),
            LuaCode:from("@lib/core/errors.nom[4103:4224]",
                "            \"Assumption failed: This value (\".._a..\") was expected to not be \".._b..\", but it was.\")\n"),
            LuaCode:from("@lib/core/errors.nom[4224:4252]", "    end\n"),
            LuaCode:from("@lib/core/errors.nom[4252:4255]", "end")) end
    end --when
    end -- if $ is...;
    end
    do return LuaCode:from("@lib/core/errors.nom[4295:4469]", "",
        LuaCode:from("@lib/core/errors.nom[4306:4313]", "if not "),
        _ENV:_1_as_lua_expr(condition),
        LuaCode:from("@lib/core/errors.nom[4338:4352]", " then\n"),
        LuaCode:from("@lib/core/errors.nom[4352:4366]", "    at_1_fail("),
        quote(Text(condition.source)), LuaCode:from("@lib/core/errors.nom[4397:4459]",
            ", \"Assumption failed: This assumption did not hold.\")\n"),
        LuaCode:from("@lib/core/errors.nom[4459:4462]", "end")) end
end);
COMPILE_RULES["assume 1 =="] = (function(_ENV, _tree, a, b)
    local mangle = mangler()
    return SyntaxTree{"assume", SyntaxTree{a, "==", b, type= "Action", source= "@lib/core/errors.nom[4508:4516]", stub= "1 =="}, type= "Action", source= "@lib/core/errors.nom[4500:4517]", stub= "assume"}
end);
COMPILE_RULES["assume 1 !="] = (function(_ENV, _tree, a, b)
    local mangle = mangler()
    return SyntaxTree{"assume", SyntaxTree{a, "!=", b, type= "Action", source= "@lib/core/errors.nom[4556:4564]", stub= "1 !="}, type= "Action", source= "@lib/core/errors.nom[4548:4565]", stub= "assume"}
end);
COMPILE_RULES["test that"] = (function(_ENV, _tree, condition)
    local mangle = mangler()
    return SyntaxTree{"assume", condition, type= "Action", source= "@lib/core/errors.nom[4601:4618]", stub= "assume"}
end);
TESTS["@lib/core/errors.nom[4624:4923]"] = "\ntry: fail\n$worked = (no)\ntry:\n    fail \"xx\"\n..if it fails with $failure:\n    $worked = (yes)\n..if it succeeds:\n    fail \"'try' incorrectly ran success case.\"\nassume ($failure, matches \"xx\")\nunless $worked:\n    fail \"'try' failed to recover from failure\"";
--  Try/except;
COMPILE_RULES["try 1 if it succeeds 2 if it fails with"] = (function(_ENV, _tree, action, success, msg, fallback)
    local successx5Flua, fallbackx5Flua, msgx5Flua;
    successx5Flua = _ENV:compile(success);
    if ((#Text(successx5Flua)) > 0) then
        successx5Flua:add("\n");
    end
    successx5Flua:prepend("-- Success:\n");
    successx5Flua:add(
        "if not _fell_through then return table.unpack(_result, 2) end");
    fallbackx5Flua = _ENV:compile(fallback);
    if ((#Text(fallbackx5Flua)) > 0) then
        msgx5Flua = _ENV:_1_as_lua_expr(msg);
    if ((#Text(msgx5Flua)) > 0) then
        fallbackx5Flua:prepend(Text("\n", msgx5Flua, " = _result[2]\n"));
    if (msgx5Flua:text()):is_lua_id() then
        fallbackx5Flua:add_free_vars(a_List{msgx5Flua:text()});
    end
    end
    end
    fallbackx5Flua:prepend("-- Failure:\n");
    do return LuaCode:from("@lib/core/errors.nom[5715:6063]", "",
        LuaCode:from("@lib/core/errors.nom[5726:5737]", "do\n"),
        LuaCode:from("@lib/core/errors.nom[5737:5777]",
            "    local _fell_through = false\n"),
        LuaCode:from("@lib/core/errors.nom[5777:5824]",
            "    local _result = {xpcall(function()\n"),
        LuaCode:from("@lib/core/errors.nom[5824:5832]", "        "),
        _ENV:compile(action), "\n",
        LuaCode:from("@lib/core/errors.nom[5858:5895]", "        _fell_through = true\n"),
        LuaCode:from("@lib/core/errors.nom[5895:5928]", "    end, enhance_error)}\n"),
        LuaCode:from("@lib/core/errors.nom[5928:5959]", "    if _result[1] then\n"),
        LuaCode:from("@lib/core/errors.nom[5959:5967]", "        "), successx5Flua,
        "\n", LuaCode:from("@lib/core/errors.nom[5989:6006]", "    else\n"),
        LuaCode:from("@lib/core/errors.nom[6006:6014]", "        "), fallbackx5Flua,
        "\n", LuaCode:from("@lib/core/errors.nom[6037:6053]", "    end\n"),
        LuaCode:from("@lib/core/errors.nom[6053:6056]", "end")) end
end)
COMPILE_RULES["try 1 if it fails with 2 3 if it succeeds"] = function(_ENV, _tree, action, msg, fallback, success) return COMPILE_RULES["try 1 if it succeeds 2 if it fails with"](_ENV, _tree, action, success, msg, fallback) end

-- File lib/core/errors.nom chunk #3
COMPILE_RULES["try"] = (function(_ENV, _tree, action)
    local mangle = mangler()
    return SyntaxTree{"try", action, "if", "it", "succeeds", SyntaxTree{"do", "nothing", type= "Action", source= "@lib/core/errors.nom[6203:6213]", stub= "do nothing"}, "if", "it", "fails", SyntaxTree{"do", "nothing", type= "Action", source= "@lib/core/errors.nom[6228:6238]", stub= "do nothing"}, type= "Action", source= "@lib/core/errors.nom[6175:6239]", stub= "try 1 if it succeeds 2 if it fails"}
end);
COMPILE_RULES["try 1 if it fails"] = (function(_ENV, _tree, action, fallback)
    local mangle = mangler()
    return SyntaxTree{"try", action, "if", "it", "succeeds", SyntaxTree{"do", "nothing", type= "Action", source= "@lib/core/errors.nom[6319:6329]", stub= "do nothing"}, "if", "it", "fails", fallback, type= "Action", source= "@lib/core/errors.nom[6291:6352]", stub= "try 1 if it succeeds 2 if it fails"}
end);
COMPILE_RULES["try 1 if it fails with"] = (function(_ENV, _tree, action, msg, fallback)
    local mangle = mangler()
    return SyntaxTree{"try", action, "if", "it", "succeeds", SyntaxTree{"do", "nothing", type= "Action", source= "@lib/core/errors.nom[6442:6452]", stub= "do nothing"}, "if", "it", "fails", "with", msg, fallback, type= "Action", source= "@lib/core/errors.nom[6414:6485]", stub= "try 1 if it succeeds 2 if it fails with"}
end);
COMPILE_RULES["try 1 if it succeeds"] = (function(_ENV, _tree, action, success)
    local mangle = mangler()
    return SyntaxTree{"try", action, "if", "it", "succeeds", success, "if", "it", "fails", SyntaxTree{"do", "nothing", type= "Action", source= "@lib/core/errors.nom[6588:6598]", stub= "do nothing"}, type= "Action", source= "@lib/core/errors.nom[6539:6599]", stub= "try 1 if it succeeds 2 if it fails"}
end);
COMPILE_RULES["try 1 if it fails 2 if it succeeds"] = (function(_ENV, _tree, action, fallback, success)
    local mangle = mangler()
    return SyntaxTree{"try", action, "if", "it", "fails", "with", SyntaxTree{"=", "lua", SyntaxTree{type= "Text", source= "@lib/core/errors.nom[6710:6712]"}, type= "Action", source= "@lib/core/errors.nom[6705:6712]", stub= "= lua"}, fallback, "if", "it", "succeeds", success, type= "Action", source= "@lib/core/errors.nom[6675:6747]", stub= "try 1 if it fails with 2 3 if it succeeds"}
end);
COMPILE_RULES["try 1 if it succeeds 2 if it fails"] = (function(_ENV, _tree, action, success, fallback)
    local mangle = mangler()
    return SyntaxTree{"try", action, "if", "it", "succeeds", success, "if", "it", "fails", "with", SyntaxTree{"=", "lua", SyntaxTree{type= "Text", source= "@lib/core/errors.nom[6882:6884]"}, type= "Action", source= "@lib/core/errors.nom[6877:6884]", stub= "= lua"}, fallback, type= "Action", source= "@lib/core/errors.nom[6823:6895]", stub= "try 1 if it succeeds 2 if it fails with"}
end);
TESTS["@lib/core/errors.nom[6901:7188]"] = "\n$success = (no)\ntry:\n    do: fail\n    ..then always:\n        $success = (yes)\n..if it succeeds:\n    fail \"'try ... then always ...' didn't propagate failure\"\n\nunless $success:\n    fail \"'try ... then always ...' didn't execute the 'always' code\"";
COMPILE_RULES["do 1 then always"] = (function(_ENV, _tree, action, finalx5Faction)
    return LuaCode:from("@lib/core/errors.nom[7241:7612]", "",
        LuaCode:from("@lib/core/errors.nom[7248:7273]", "do -- do/then always\n"),
        LuaCode:from("@lib/core/errors.nom[7273:7309]",
            "    local _fell_through = false\n"),
        LuaCode:from("@lib/core/errors.nom[7309:7353]",
            "    local _results = {xpcall(function()\n"),
        LuaCode:from("@lib/core/errors.nom[7353:7361]", "        "),
        _ENV:compile(action), "\n",
        LuaCode:from("@lib/core/errors.nom[7383:7416]", "        _fell_through = true\n"),
        LuaCode:from("@lib/core/errors.nom[7416:7445]", "    end, enhance_error)}\n"),
        LuaCode:from("@lib/core/errors.nom[7445:7449]", "    "),
        _ENV:compile(finalx5Faction), "\n",
        LuaCode:from("@lib/core/errors.nom[7477:7535]",
            "    if not _results[1] then error(_results[2], 0) end\n"),
        LuaCode:from("@lib/core/errors.nom[7535:7606]",
            "    if not _fell_through then return table.unpack(_results, 2) end\n"),
        LuaCode:from("@lib/core/errors.nom[7606:7609]", "end"))
end);
