#!/usr/bin/env nomsu -V7.0.0-- File lib/core/id.nom chunk #1
-- 
-- A simple UUID function based on RFC 4122: http://www.ietf.org/rfc/rfc4122.txt
-- ;
_ENV:use("core/metaprogramming");
_ENV:use("core/operators");
_ENV:use("core/math");
_ENV:use("core/collections");
_ENV:use("core/control_flow");

-- File lib/core/id.nom chunk #2
local NaNx5Fsurrogate, nilx5Fsurrogate, objx5Fbyx5Fid, idx5Fbyx5Fobj;
NaNx5Fsurrogate = a_Dict{};
nilx5Fsurrogate = a_Dict{};
objx5Fbyx5Fid = a_Dict{};
setmetatable(objx5Fbyx5Fid, a_Dict{__mode = "v";});
idx5Fbyx5Fobj = a_Dict{};
setmetatable(idx5Fbyx5Fobj, a_Dict{
    __mode = "k"; __index = (function(self, key)
        local id;
        if (key == (nil)) then
            do return self[nilx5Fsurrogate] end
        end
        if (key ~= key) then
            do return self[NaNx5Fsurrogate] end
        end
        ::label_retry::;
        id = uuid();
        if (objx5Fbyx5Fid[id] ~= (nil)) then
            goto label_retry;
        end
        self[key] = id;
        objx5Fbyx5Fid[id] = key;
        do return id end
    end);
});
uuid = (function()
    local bytes;
    --  Set all the other bits to randomly (or pseudo-randomly) chosen values.;
    bytes = a_List{
        --  time-low, time-mid, time-high-and-version
        math.random(2 ^ (4 * 8)), math.random(2 ^ (2 * 8)), math.random(2 ^ (2 * 8 - 4)), --  clock-seq-and-reserved, clock-seq-low
        math.random(2 ^ (1 * 8 - 2)), math.random(2 ^ (1 * 8)), math.random(2 ^ (3 * 8)), --  node
        math.random(2 ^ (3 * 8))
    };
    --  Set the four most significant bits (bits 12 through 15) of the;
    --  time_hi_and_version field to the 4-bit version number from;
    --  Section 4.1.3.;
    bytes[3] = ((bytes[3] or 0)) + 0x4000;
    --  Set the two most significant bits (bits 6 and 7) of the;
    --  clock_seq_hi_and_reserved to zero and one, respectively.;
    bytes[4] = ((bytes[4] or 0)) + 0xC0;
    do return ('%08x-%04x-%04x-%02x%02x-%6x%6x'):format(unpack(bytes)) end
end);
--  For strict identity checking, use ($x's id) == ($y's id);
TESTS["@lib/core/id.nom[1941:2175]"] = "\nassume (([] == []) and ((id of []) != (id of [])))\nseed random with 0\n$x = []\nassume ((id of $x) == (id of $x))\nseed random with 0\nassume ((id of $x) != (id of []))\nseed random";
id_of = (function(_)
    return idx5Fbyx5Fobj[_]
end);
_1_x27_s_id = id_of;
_1_x27_id = id_of;
