#!/usr/bin/env nomsu -V7.0.0-- File lib/core/math.nom chunk #1
-- 
-- This file defines some common math literals and functions
-- ;
_ENV:use("core/metaprogramming");
_ENV:use("core/text");
_ENV:use("core/operators");
_ENV:use("core/control_flow");
_ENV:use("core/collections");

-- File lib/core/math.nom chunk #2
--  Literals:;
TESTS["@lib/core/math.nom[331:517]"] = "\nunless (all of [inf, NaN, pi, tau, golden ratio, e]):\n    fail \"math constants failed\"\n$nan = (NaN)\nunless ($nan != $nan):\n    fail \"NaN failed\"";
COMPILE_RULES["infinity"] = (function(_ENV, _tree)
    return LuaCode:from("@lib/core/math.nom[558:569]", "math.huge")
end)
COMPILE_RULES["inf"] = COMPILE_RULES["infinity"];
COMPILE_RULES["not a number"] = (function(_ENV, _tree)
    return LuaCode:from("@lib/core/math.nom[614:621]", "(0/0)")
end)
COMPILE_RULES["NaN"] = COMPILE_RULES["not a number"]
COMPILE_RULES["nan"] = COMPILE_RULES["not a number"];
COMPILE_RULES["pi"] = (function(_ENV, _tree)
    return LuaCode:from("@lib/core/math.nom[654:663]", "math.pi")
end)
COMPILE_RULES["Pi"] = COMPILE_RULES["pi"]
COMPILE_RULES["PI"] = COMPILE_RULES["pi"];
COMPILE_RULES["tau"] = (function(_ENV, _tree)
    return LuaCode:from("@lib/core/math.nom[699:712]", "(2*math.pi)")
end)
COMPILE_RULES["Tau"] = COMPILE_RULES["tau"]
COMPILE_RULES["TAU"] = COMPILE_RULES["tau"];
COMPILE_RULES["golden ratio"] = (function(_ENV, _tree)
    return LuaCode:from("@lib/core/math.nom[744:766]", "((1+math.sqrt(5))/2)")
end);
COMPILE_RULES["e"] = (function(_ENV, _tree)
    return LuaCode:from("@lib/core/math.nom[787:800]", "math.exp(1)")
end);
--  Functions:;
TESTS["@lib/core/math.nom[833:874]"] = "\nassume ((\"5\" as a number) == 5)";
_1_as_a_number = tonumber;
_1_as_number = tonumber;
TESTS["@lib/core/math.nom[955:1339]"] = "\nunless\n    all of [\n        abs 5, | 5 |, sqrt 5, \226\136\1545, sine 5, cosine 5, tangent 5, arc sine 5, arc cosine 5\n        arc tangent 5, arc tangent 5 / 10, hyperbolic sine 5, hyperbolic cosine 5\n        hyperbolic tangent 5, e^ 5, ln 5, log 5 base 2, floor 5, ceiling 5, round 5\n    ]\n..:\n    fail \"math functions failed\"";
absolute_value, absolute_value_of, x7C_1_x7C, abs = math.abs, math.abs, math.abs, math.abs;
square_root, square_root_of, xE2x88x9A, sqrt = math.sqrt, math.sqrt, math.sqrt, math.sqrt;
sine, sin = math.sin, math.sin;
cosine, cos = math.cos, math.cos;
tangent, tan = math.tan, math.tan;
arc_sine, asin = math.asin, math.asin;
arc_cosine, acos = math.acos, math.acos;
arc_tangent, atan = math.atan, math.atan;
arc_tangent_1_x2F, atan2 = math.atan2, math.atan2;
hyperbolic_sine, sinh = math.sinh, math.sinh;
hyperbolic_cosine, cosh = math.cosh, math.cosh;
hyperbolic_tangent, tanh = math.tanh, math.tanh;
e_x5E, exp = math.exp, math.exp;
natural_log, ln, log, log_1_base = math.log, math.log, math.log, math.log;
floor = math.floor;
ceiling, ceil = math.ceil, math.ceil;
round = (function(_)
    return floor(_ + 0.5)
end);
_1_rounded = round;
TESTS["@lib/core/math.nom[2523:2671]"] = "\nunless ((463 to the nearest 100) == 500): fail \"rounding failed\"\nunless ((2.6 to the nearest 0.25) == 2.5): fail \"rounding failed\"";
_1_to_the_nearest = (function(n, rounder)
    return rounder * (floor(n / rounder + 0.5))
end);
--  Any/all;
all_of = (function(items)
    do -- for-loop
        for _i,_ in _ipairs(items) do
            if (not _) then
        do return (false) end
    end
        end
    end -- for-loop;
    do return (true) end
end);
all = all_of;
COMPILE_RULES["not all of"] = (function(_ENV, _tree, items)
    local mangle = mangler()
    return SyntaxTree{"not", SyntaxTree{"all", "of", items, type= "Action", source= "@lib/core/math.nom[2981:2994]", stub= "all of"}, type= "Action", source= "@lib/core/math.nom[2976:2995]", stub= "not"}
end)
COMPILE_RULES["not all"] = COMPILE_RULES["not all of"];
any_of = (function(items)
    do -- for-loop
        for _i,_ in _ipairs(items) do
            if _ then
        do return (true) end
    end
        end
    end -- for-loop;
    do return (false) end
end);
any = any_of;
COMPILE_RULES["none of"] = (function(_ENV, _tree, items)
    local mangle = mangler()
    return SyntaxTree{"not", SyntaxTree{"any", "of", items, type= "Action", source= "@lib/core/math.nom[3193:3206]", stub= "any of"}, type= "Action", source= "@lib/core/math.nom[3188:3207]", stub= "not"}
end)
COMPILE_RULES["none"] = COMPILE_RULES["none of"];
--  Sum/product;
sum_of = (function(items)
    local total;
    total = 0;
    do -- for-loop
        for _i,_ in _ipairs(items) do
            total = ((total or 0)) + _;
        end
    end -- for-loop;
    do return total end
end);
sum = sum_of;
product_of = (function(items)
    local prod;
    prod = 1;
    do -- for-loop
        for _i,_ in _ipairs(items) do
            prod = ((prod or 1)) * _;
        end
    end -- for-loop;
    do return prod end
end);
product = product_of;
avg_of = (function(items)
    return (sum_of(items)) / ((#items))
end);
average_of = avg_of;
--  Min/max;
min_of = (function(items)
    local best;
    best = (nil);
    do -- for-loop
        for _i,_ in _ipairs(items) do
            if ((best == (nil)) or (_ < best)) then
        best = _;
    end
        end
    end -- for-loop;
    do return best end
end);
smallest_of = min_of;
lowest_of = min_of;
max_of = (function(items)
    local best;
    best = (nil);
    do -- for-loop
        for _i,_ in _ipairs(items) do
            if ((best == (nil)) or (_ > best)) then
        best = _;
    end
        end
    end -- for-loop;
    do return best end
end);
biggest_of = max_of;
largest_of = max_of;
highest_of = max_of;
TESTS["@lib/core/math.nom[4039:4161]"] = "\nassume ((min of [3, -4, 1, 2] by $ = ($ * $)) == 1)\nassume ((max of [3, -4, 1, 2] by $ = ($ * $)) == -4)";
COMPILE_RULES["min of 1 by 2 ="] = (function(_ENV, _tree, items, item, valuex5Fexpr)
    local mangle = mangler()
    return SyntaxTree{"result", "of", SyntaxTree{SyntaxTree{SyntaxTree{mangle("best"), type="Var", source="@lib/core/math.nom[4251:4256]"}, "=", SyntaxTree{"nil", type= "Action", source= "@lib/core/math.nom[4260:4263]", stub= "nil"}, type= "Action", source= "@lib/core/math.nom[4251:4264]", stub= "1 ="}, SyntaxTree{SyntaxTree{mangle("best_key"), type="Var", source="@lib/core/math.nom[4277:4286]"}, "=", SyntaxTree{"nil", type= "Action", source= "@lib/core/math.nom[4290:4293]", stub= "nil"}, type= "Action", source= "@lib/core/math.nom[4277:4294]", stub= "1 ="}, SyntaxTree{"for", item, "in", items, SyntaxTree{SyntaxTree{SyntaxTree{mangle("key"), type="Var", source="@lib/core/math.nom[4344:4348]"}, "=", valuex5Fexpr, type= "Action", source= "@lib/core/math.nom[4344:4362]", stub= "1 ="}, SyntaxTree{"if", SyntaxTree{SyntaxTree{SyntaxTree{mangle("best"), type="Var", source="@lib/core/math.nom[4384:4389]"}, "==", SyntaxTree{"nil", type= "Action", source= "@lib/core/math.nom[4394:4397]", stub= "nil"}, type= "Action", source= "@lib/core/math.nom[4384:4398]", stub= "1 =="}, "or", SyntaxTree{SyntaxTree{mangle("key"), type="Var", source="@lib/core/math.nom[4404:4408]"}, "<", SyntaxTree{mangle("best_key"), type="Var", source="@lib/core/math.nom[4411:4420]"}, type= "Action", source= "@lib/core/math.nom[4404:4420]", stub= "1 <"}, type= "Action", source= "@lib/core/math.nom[4383:4421]", stub= "1 or"}, SyntaxTree{SyntaxTree{SyntaxTree{mangle("best"), type="Var", source="@lib/core/math.nom[4444:4449]"}, "=", item, type= "Action", source= "@lib/core/math.nom[4444:4457]", stub= "1 ="}, SyntaxTree{SyntaxTree{mangle("best_key"), type="Var", source="@lib/core/math.nom[4478:4487]"}, "=", SyntaxTree{mangle("key"), type="Var", source="@lib/core/math.nom[4490:4494]"}, type= "Action", source= "@lib/core/math.nom[4478:4494]", stub= "1 ="}, type= "Block", source= "@lib/core/math.nom[4422:4494]"}, type= "Action", source= "@lib/core/math.nom[4379:4494]", stub= "if"}, type= "Block", source= "@lib/core/math.nom[4326:4494]"}, type= "Action", source= "@lib/core/math.nom[4307:4494]", stub= "for 1 in"}, SyntaxTree{"return", SyntaxTree{mangle("best"), type="Var", source="@lib/core/math.nom[4527:4532]"}, type= "Action", source= "@lib/core/math.nom[4520:4532]", stub= "return"}, type= "Block", source= "@lib/core/math.nom[4237:4532]"}, type= "Action", source= "@lib/core/math.nom[4228:4532]", stub= "result of"}
end);
COMPILE_RULES["max of 1 by 2 ="] = (function(_ENV, _tree, items, item, valuex5Fexpr)
    local mangle = mangler()
    return SyntaxTree{"result", "of", SyntaxTree{SyntaxTree{SyntaxTree{mangle("best"), type="Var", source="@lib/core/math.nom[4622:4627]"}, "=", SyntaxTree{"nil", type= "Action", source= "@lib/core/math.nom[4631:4634]", stub= "nil"}, type= "Action", source= "@lib/core/math.nom[4622:4635]", stub= "1 ="}, SyntaxTree{SyntaxTree{mangle("best_key"), type="Var", source="@lib/core/math.nom[4648:4657]"}, "=", SyntaxTree{"nil", type= "Action", source= "@lib/core/math.nom[4661:4664]", stub= "nil"}, type= "Action", source= "@lib/core/math.nom[4648:4665]", stub= "1 ="}, SyntaxTree{"for", item, "in", items, SyntaxTree{SyntaxTree{SyntaxTree{mangle("key"), type="Var", source="@lib/core/math.nom[4715:4719]"}, "=", valuex5Fexpr, type= "Action", source= "@lib/core/math.nom[4715:4733]", stub= "1 ="}, SyntaxTree{"if", SyntaxTree{SyntaxTree{SyntaxTree{mangle("best"), type="Var", source="@lib/core/math.nom[4755:4760]"}, "==", SyntaxTree{"nil", type= "Action", source= "@lib/core/math.nom[4765:4768]", stub= "nil"}, type= "Action", source= "@lib/core/math.nom[4755:4769]", stub= "1 =="}, "or", SyntaxTree{SyntaxTree{mangle("key"), type="Var", source="@lib/core/math.nom[4775:4779]"}, ">", SyntaxTree{mangle("best_key"), type="Var", source="@lib/core/math.nom[4782:4791]"}, type= "Action", source= "@lib/core/math.nom[4775:4791]", stub= "1 >"}, type= "Action", source= "@lib/core/math.nom[4754:4792]", stub= "1 or"}, SyntaxTree{SyntaxTree{SyntaxTree{mangle("best"), type="Var", source="@lib/core/math.nom[4815:4820]"}, "=", item, type= "Action", source= "@lib/core/math.nom[4815:4828]", stub= "1 ="}, SyntaxTree{SyntaxTree{mangle("best_key"), type="Var", source="@lib/core/math.nom[4849:4858]"}, "=", SyntaxTree{mangle("key"), type="Var", source="@lib/core/math.nom[4861:4865]"}, type= "Action", source= "@lib/core/math.nom[4849:4865]", stub= "1 ="}, type= "Block", source= "@lib/core/math.nom[4793:4865]"}, type= "Action", source= "@lib/core/math.nom[4750:4865]", stub= "if"}, type= "Block", source= "@lib/core/math.nom[4697:4865]"}, type= "Action", source= "@lib/core/math.nom[4678:4865]", stub= "for 1 in"}, SyntaxTree{"return", SyntaxTree{mangle("best"), type="Var", source="@lib/core/math.nom[4898:4903]"}, type= "Action", source= "@lib/core/math.nom[4891:4903]", stub= "return"}, type= "Block", source= "@lib/core/math.nom[4608:4903]"}, type= "Action", source= "@lib/core/math.nom[4599:4903]", stub= "result of"}
end);
TESTS["@lib/core/math.nom[4917:4970]"] = "\nassume (100 clamped between 0 and 10) == 10";
_1_clamped_between_2_and = (function(_, min, max)
    if (_ < min) then
        do return min end
    elseif (_ > max) then
        do return max end
    else
        do return _ end
    end --when;
end);
TESTS["@lib/core/math.nom[5221:5431]"] = "\nassume (-0.1 smoothed by 2.7) == 0\nassume (0 smoothed by 2.7) == 0\nassume (0.5 smoothed by 2.7) == 0.5\nassume (1 smoothed by 2.7) == 1\nassume (1.1 smoothed by 2.7) == 1";
_1_smoothed_by = (function(_, smoothness)
    local k;
    _ = _1_clamped_between_2_and(_, 0, 1);
    if (smoothness == 0) then
        do return _ end
    end
    k = 2 ^ smoothness;
    if (_ < 0.5) then
        do return 0.5 * (2 * _) ^ k end
    else
        do return 1 - 0.5 * (2 - 2 * _) ^ k end
    end
end);
TESTS["@lib/core/math.nom[5726:5930]"] = "\nassume (5 to 7 mixed by -1) == 5\nassume (5 to 7 mixed by 0) == 5\nassume (5 to 7 mixed by 0.5) == 6\nassume (5 to 7 mixed by 1) == 7\nassume (5 to 7 mixed by 2) == 7";
_1_to_2_mixed_by = (function(lo, hi, amount)
    local _;
    _ = _1_clamped_between_2_and(amount, 0, 1);
    do return (1 - _) * lo + _ * hi end
end);
TESTS["@lib/core/math.nom[6077:6350]"] = "\nassume ([0, 1, 11] mixed by 0) == 0\nassume ([0, 1, 11] mixed by 0.25) == 0.5\nassume ([0, 1, 11] mixed by 0.5) == 1\nassume ([0, 1, 11] mixed by 0.75) == 6\nassume ([0, 1, 11] mixed by 1) == 11\nassume ([99] mixed by 0.5) == 99";
_1_mixed_by = (function(nums, amount)
    local _, i, lo, hi;
    _ = _1_clamped_between_2_and(amount, 0, 1);
    i = 1 + (_ * (((#nums)) - 1));
    if (floor(i) == (#nums)) then
        do return nums[floor(i)] end
    end
    lo, hi = nums[floor(i)], nums[floor(i + 1)];
    do return _1_to_2_mixed_by(lo, hi, ((i) % (1))) end
end);
--  Random functions;
seed_random_with = (function(_)
    math.randomseed(_);
    for i=1,20 do math.random(); end
end);
COMPILE_RULES["seed random"] = (function(_ENV, _tree)
    local mangle = mangler()
    return SyntaxTree{"seed", "random", "with", SyntaxTree{"=", "lua", SyntaxTree{"os.time()", type= "Text", source= "@lib/core/math.nom[6878:6889]"}, type= "Action", source= "@lib/core/math.nom[6873:6889]", stub= "= lua"}, type= "Action", source= "@lib/core/math.nom[6855:6890]", stub= "seed random with"}
end);
COMPILE_RULES["random number"] = (function(_ENV, _tree)
    return LuaCode:from("@lib/core/math.nom[6941:6956]", "math.random()")
end)
COMPILE_RULES["random"] = COMPILE_RULES["random number"]
COMPILE_RULES["rand"] = COMPILE_RULES["random number"];
COMPILE_RULES["random int"] = (function(_ENV, _tree, n)
    return LuaCode:from("@lib/core/math.nom[7031:7063]", "math.random(",
        _ENV:_1_as_lua_expr(n), ")")
end)
COMPILE_RULES["random integer"] = COMPILE_RULES["random int"]
COMPILE_RULES["randint"] = COMPILE_RULES["random int"];
COMPILE_RULES["random from 1 to"] = (function(_ENV, _tree, low, high)
    return LuaCode:from("@lib/core/math.nom[7173:7229]", "math.random(",
        _ENV:_1_as_lua_expr(low), ", ", _ENV:_1_as_lua_expr(high), ")")
end)
COMPILE_RULES["random number from 1 to"] = COMPILE_RULES["random from 1 to"]
COMPILE_RULES["rand"] = COMPILE_RULES["random from 1 to"];
random_choice_from = (function(elements)
    return elements[math.random(#elements)]
end);
random_choice = random_choice_from;
random = random_choice_from;
