#!/usr/bin/env nomsu -V7.0.0-- File lib/core/text.nom chunk #1
-- 
-- This file contains some definitions of text escape sequences, including ANSI console
-- color codes.
-- ;
_ENV:use("core/metaprogramming");
_ENV:use("core/operators");
_ENV:use("core/control_flow");

-- File lib/core/text.nom chunk #2
local escapes;
TESTS["@lib/core/text.nom[304:966]"] = "\nassume \"\\[1, 2, 3]\" == \"[1, 2, 3]\"\nassume \"foo = \\(1 + 2)!\" == \"foo = 3!\"\nassume (\"\n    one\n    two\n\") == (\"\n    one\n    two\n\")\nassume \"nogap\" == \"nogap\"\nassume ([\"x\", \"y\"], joined with \",\") == \"x,y\"\nassume ([\"x\", \"y\"], joined) == \"xy\"\nassume (\"BAR\", byte 2) == 65\nassume (\"BAR\", bytes 1 to 2) == [66, 65]\nassume (\"asdf\", capitalized) == \"Asdf\"\nassume (\"asdf\", uppercase) == \"ASDF\"\nassume (\"asdf\", with \"s\" -> \"X\") == \"aXdf\"\nassume\n    (\"\n        one\n        two\n        \n    \"), lines\n..== [\"one\", \"two\", \"\"]\n($spec \227\129\168\227\129\175 $body) parses as ($spec means $body)";
TESTS["@lib/core/text.nom[972:1119]"] = "\n$\227\129\147\227\130\147\227\129\171\227\129\161\227\129\175 = \"\227\129\147\227\130\147\227\129\171\227\129\161\227\129\175\"\n($ \227\129\168\232\168\128\227\129\134) \227\129\168\227\129\175 \"\\($)\228\184\150\231\149\140\"\nassume ($\227\129\147\227\130\147\227\129\171\227\129\161\227\129\175 \227\129\168\232\168\128\227\129\134) == \"\227\129\147\227\130\147\227\129\171\227\129\161\227\129\175\228\184\150\231\149\140\"";
COMPILE_RULES["1 for 2 in 3 matching"] = (function(_ENV, _tree, expr, match, text, patt)
    local mangle = mangler();
    do return LuaCode:from("@lib/core/text.nom[1211:1557]", "",
        LuaCode:from("@lib/core/text.nom[1222:1242]", "(function()\n"),
        LuaCode:from("@lib/core/text.nom[1242:1252]", "    local "),
        mangle("comprehension"),
        LuaCode:from("@lib/core/text.nom[1277:1297]", " = a_List{}\n"),
        LuaCode:from("@lib/core/text.nom[1297:1305]", "    for "),
        _ENV:_1_as_lua_expr(match),
        LuaCode:from("@lib/core/text.nom[1326:1331]", " in ("),
        _ENV:_1_as_lua_expr(text),
        LuaCode:from("@lib/core/text.nom[1351:1360]", "):gmatch("),
        _ENV:_1_as_lua_expr(patt),
        LuaCode:from("@lib/core/text.nom[1380:1393]", ") do\n"),
        LuaCode:from("@lib/core/text.nom[1393:1401]", "        "),
        mangle("comprehension"), LuaCode:from("@lib/core/text.nom[1426:1428]", "[#"),
        mangle("comprehension"),
        LuaCode:from("@lib/core/text.nom[1453:1459]", "+1] = "), _ENV:compile(expr),
        "\n", LuaCode:from("@lib/core/text.nom[1483:1499]", "    end\n"),
        LuaCode:from("@lib/core/text.nom[1499:1510]", "    return "),
        mangle("comprehension"), "\n",
        LuaCode:from("@lib/core/text.nom[1544:1550]", "end)()")) end
end);
TESTS["@lib/core/text.nom[1563:1593]"] = "\nassume \"\\n\" == (newline)";
TESTS["@lib/core/text.nom[1599:1647]"] = "\nassume (0xDEADBEEF as hex) == \"0xDEADBEEF\"";
_1_as_hex = (function(num)
    if (num < 0) then
        do return ("-0x%X"):formatted_with((-(num))) end
    else
        do return ("0x%X"):formatted_with(num) end
    end
end);
--  Text literals;
escapes = a_Dict{
    nl = "\n"; newline = "\n"; tab = "\009"; bell = "\007"; cr = "\013"; ["carriage return"] = "\013";
        backspace = "\008"; ["form feed"] = "\012"; formfeed = "\012"; ["vertical tab"] = "\011";
};
do -- for-loop
    for name,str in pairs(escapes) do
        do
    local lua = LuaCode:from("@lib/core/text.nom[2099:2109]", quote(str));;
    COMPILE_RULES[name] = (function()
    return lua
end);
end -- 'with' block;
    end
end -- for-loop;
