#!/usr/bin/env nomsu -V7.0.0-- File lib/core/things.nom chunk #1
-- 
-- A library for simple object oriented programming.
-- ;
_ENV:use("core/metaprogramming");
_ENV:use("core/operators");
_ENV:use("core/control_flow");
_ENV:use("core/collections");
_ENV:use("core/errors");

-- File lib/core/things.nom chunk #2
local METAMETHODx5FMAP, _1_as_text_like_a_dict;
TESTS["@lib/core/things.nom[293:1756]"] = "\n(an Empty) is (a thing) with []\n(a Buffer) is (a thing) with [$bits]:\n    $self.is_a_buffer = (yes)\n    ($self, set up) means:\n        $bits or= []\n    ($self, as text) means ($bits, joined)\n    [($self, add $bit), ($self, append $bit)] all mean: $bits, add $bit\nassume $(a Buffer).is_a_buffer\n$b = (a Buffer)\nassume (type of $b) == \"a Buffer\"\nassume ($b is \"a Buffer\")\nassume $b.is_a_buffer\nassume \"\\$b\" == \"\"\nassume ($b, as text) == \"\"\n$b = (a Buffer {.bits = [\"x\"]})\n$b, \n    add \"y\"\n    append \"z\"\nassume \"\\$b\" == \"xyz\"\nassume $b == (a Buffer {.bits = [\"x\", \"y\", \"z\"]})\nassume $b != (a Buffer {.bits = []})\n(a Comma Buffer) is (a Buffer) with [$bits]:\n    ($self, as text) means ($bits, joined with \",\")\n    ($self, number of commas) means (#$bits - 1)\n$csv = (a Comma Buffer)\nassume $csv.is_a_buffer\nassume ($csv is \"a Comma Buffer\")\nassume ($csv is \"a Buffer\")\nassume \"\\$csv\" == \"\"\n$csv, add \"x\"\n$csv, add \"y\"\nassume \"\\$csv\" == \"x,y\"\nassume ($csv, number of commas) == 1\n(a Vec) is (a thing) with [$x, $y]:\n    ($self, +$other) means (Vec ($x + $other.x) ($y + $other.y))\n    ($self, length) means (sqrt ($x * $x + $y * $y))\n(Vec $x $y) means (a Vec {.x = $x, .y = $y})\nassume ((Vec 1 2) + (Vec 10 10)) == (Vec 11 12)\nassume (((Vec 1 2) + (Vec 10 10)) != (Vec 0 0))\nassume (Vec 3 4, length) == 5";
METAMETHODx5FMAP = a_Dict{
    ["as text"] = "__tostring"; ["clean up"] = "__gc"; ["+"] = "__add"; ["-"] = "__sub";
        ["*"] = "__mul"; ["/"] = "__div"; negative = "__unm"; ["//"] = "__idiv"; mod = "__mod";
        ["^"] = "__pow"; ["&"] = "__band"; ["|"] = "__bor"; ["~"] = "__bxor"; ["~"] = "__bnot";
        ["<<"] = "__bshl"; [">>"] = "__bshr"; ["=="] = "__eq"; ["<"] = "__lt"; ["<="] = "__le";
        ["set 1 ="] = "__newindex"; ["fallback for"] = "__index"; size = "__len"; iterate = "__ipairs";
        ["iterate all"] = "__pairs";
};
_1_as_text_like_a_dict = getmetatable(a_Dict{}).__tostring;
_1_class_named = (function(parent, classname, initialize)
    local class;
    class = a_Dict{__type = classname;};
    class.__index = class;
    class.class = class;
    class.__tostring = (function(_)
        return Text(_.__type, " ", _1_as_text_like_a_dict(_))
    end);
    class.__eq = getmetatable(a_Dict{}).__eq;
    class.__len = getmetatable(a_Dict{}).__len;
    setmetatable(class, a_Dict{
        __index = parent; __tostring = (function(class)
            return class.__type
        end); __call = (function(class, initialx5Fvalues)
            initialx5Fvalues = (initialx5Fvalues or a_Dict{});
            setmetatable(initialx5Fvalues, class);
            if initialx5Fvalues.set_up then
                initialx5Fvalues:set_up();
            end
            do return initialx5Fvalues end
        end);
    });
    if initialize then
        initialize(class);
    do -- for-loop
        for stub,metamethod in pairs(METAMETHODx5FMAP) do
            if class[stub:as_lua_id()] then
        class[metamethod] = class[stub:as_lua_id()];
    end
        end
    end -- for-loop;
    end
    do return class end
end);
a_thing = _1_class_named((nil), "thing");
COMPILE_RULES["1 is 2 with"] = (function(_ENV, _tree, classname, parent, vars, classx5Fbody)
    local classx5Fid, lua;
    if (not (vars.type == "List")) then
        at_1_fail(vars, "Compile error: This is not a list of variables.");
    end
    classx5Fid = classname.stub:as_lua_id();
    classx5Fbody = (classx5Fbody and classx5Fbody:with(
        (function(t)
            do -- for-loop
                for _i,v in _ipairs(vars) do
                    if (t == v) then
                do return _1_tree_with("IndexChain", _1_tree_with("Var", "self"),
                _1_tree_with("Index", _1_tree_with("Text", v[1]))) end
            end
                end
            end -- for-loop;
        end)));
    if (parent.type == "Action") then
        parent = _1_tree_with("Var", parent);
    end
    lua = LuaCode:from("@lib/core/things.nom[4110:4557]", "", classx5Fid,
        LuaCode:from("@lib/core/things.nom[4139:4157]", " = _1_class_named("),
        _1_as_lua_id(parent), LuaCode:from("@lib/core/things.nom[4177:4179]", ", "),
        quote(classname.stub), ((function()
            if classx5Fbody then
                return LuaCode:from("@lib/core/things.nom[4256:4478]", "",
            LuaCode:from("@lib/core/things.nom[4287:4298]", ", function("), classx5Fid,
            LuaCode:from("@lib/core/things.nom[4308:4338]", ")\n"),
            LuaCode:from("@lib/core/things.nom[4338:4355]", "    local self = "),
            classx5Fid, "\n", LuaCode:from("@lib/core/things.nom[4394:4398]", "    "),
            _ENV:compile(classx5Fbody), "\n",
            LuaCode:from("@lib/core/things.nom[4448:4451]", "end"))
            else
                return ""
            end
        end)()), LuaCode:from("@lib/core/things.nom[4541:4542]", ")"));
    lua:add_free_vars(a_List{classx5Fid});
    do return lua end
end);
