#!/usr/bin/env nomsu -V7.0.0-- File lib/core/time.nom chunk #1
-- 
-- This file defines time-related actions.
-- ;
_ENV:use("core/metaprogramming");
_ENV:use("core/operators");
_ENV:use("core/control_flow");
_ENV:use("core/io");
_ENV:use("core/things");

-- File lib/core/time.nom chunk #2
a_Time = _1_class_named(a_thing, "a Time", function(a_Time)
    local self = a_Time
    self.x2B = (function(self, other)
    if (_1_is(self, "a Time") and _1_is(other, "a Time")) then
        at_1_fail("@lib/core/time.nom[500:664]",
        Text("Type error: Cannot add two times together.\n",
      "Hint: One of these two should be a number, not a time.")
    );
    end
    if (not _1_is(other, "a Number")) then
        other = os.time(other);
    end
    if (not _1_is(self, "a Number")) then
        self = os.time(self);
    end
    do return a_Time(os.date("*t", (self + other):rounded())) end
end);
self.x2D = (function(self, other)
    if (not _1_is(self, "a Time")) then
        at_1_fail("@lib/core/time.nom[1037:1112]",
        "Type error: Cannot subtract a Time from something that isn't a Time."
    );
    end
    self = os.time(self);
    if _1_is(other, "a Time") then
        do return os.difftime(self, os.time(other)) end
    end
    do return a_Time(os.date("*t", (self - other):rounded())) end
end);
self.x3C = (function(self, other)
    return (self:since_epoch() < other:since_epoch())
end);
self.x3Cx3D = (function(self, other)
    return (self:since_epoch() <= other:since_epoch())
end);
self.as_text = (function(self)
    return os.date("%I:%M%p %a %b %e %Y", os.time(self))
end);
self.as_text_in_format = (function(self, format)
    return os.date(format, os.time(self))
end);
self.since_epoch = (function(self)
    return os.time(self)
end);
end);
now = (function()
    do return a_Time(os.date("*t")) end
end);
sleep_for_1_seconds = (function(t)
    local deadline;
    --  Lua does not come with a sleep() function, only an os.clock() function,
    -- so this busy-loop is necessary for cross-platform compatibility.;
    deadline = (os.clock()) + t;
    while (os.clock() < deadline) do
        ;
    end --while-loop;
end);
sleep_for_1_second = sleep_for_1_seconds;
