#!/usr/bin/env nomsu -V7.0.0-- File lib/file_hash/init.nom chunk #1
-- 
-- This file defines some actions for hashing files and looking up files by hash.
-- ;
_ENV:use("filesystem");
_ENV:use("base64");

-- File lib/file_hash/init.nom chunk #2
local usex5Fsha1, hashlib = pcall(require, 'openssl.digest');
TESTS["@lib/file_hash/init.nom[309:1030]"] = "\nassume (hash \"hello world\") == (hash \"hello world\")\nif ((hash \"hello world\") == (hash \"goodbye\")):\n    fail (\"\n        Hash collision:\n            (hash \"hello world\") = \\(hash \"hello world\")\n            (hash \"goodbye\") = \\(hash \"goodbye\")\n    \")\n\nassume\n    (\n        hash (\"\n            This is a really long string meant to stress test the hashing function and\n            ensure that it's not overflowing with long inputs.\n        \")\n    ) != \"inf\"\n\nif ((hash \"\\000\") == (hash \"\\000\\000\\000\\000\\000\")):\n    fail \"Incorrect hashing of null strings\"\n\nif $use_sha1:\n    assume ((hash \"hello world\") == \"Kq5sNclPz7QV2+lfQIuc6R7oRu0=\")";
if usex5Fsha1 then
    hash = (function(_)
    local hash;
    hash = hashlib.new('sha1'):final(_);
    do return base64(hash) end
end);
else
    --  TODO: remove warning?;
say(
    Text("\027[31;1mWARNING: OpenSSL module not found. Defaulting to a non-cryptographically secure hash function.\027[0m"));
hash = (function(_)
    local bytes, hash;
    bytes = _:bytes();
    hash = Bit.lshift(bytes[1], 7);
    do -- for-loop
        local _start = 2
    for i=_start,(#bytes) do
            hash = Bit.bxor(1000003 * hash, bytes[i]);
        end
    end -- for-loop;
    hash = Bit.bxor(hash, (#bytes));
    do return Text(hash) end
end);
end
file_with_hash = (function(hash)
    local contents, filex5Fhash;
    do -- for-loop
        for _i,filename in _ipairs(files_for(".")) do
            contents = read_file(filename);
    filex5Fhash = hash(contents);
    if (filex5Fhash == hash) then
        do return filename end
    end
        end
    end -- for-loop;
end);
COMPILE_RULES["hash of file"] = (function(_ENV, _tree, filename)
    local mangle = mangler()
    return SyntaxTree{"hash", SyntaxTree{"read", "file", filename, type= "Action", source= "@lib/file_hash/init.nom[1935:1954]", stub= "read file"}, type= "Action", source= "@lib/file_hash/init.nom[1929:1955]", stub= "hash"}
end);
