#!/usr/bin/env nomsu -V7.0.0-- File lib/tools/format.nom chunk #1
-- 
-- Auto-format Nomsu code. Usage:
-- nomsu -t format [-i] file1 file2...
-- 
-- If the "-i" flag is used, the file will be edited in-place.
-- If the "-q" flag is used and an error occurs, the original file will be printed.
-- If no files are passed in, this will read from stdin.
-- ;
_ENV:use("filesystem");
_ENV:use("commandline");

-- File lib/tools/format.nom chunk #2
run_with = (function(args)
    local filenames, file, leadingx5Findent, code, tree, formatted, msg;
    filenames = args.extras;
    if ((#filenames) == 0) then
        say(
        Text("Warning: reading from stdin (ctrl-d to abort). To avoid this message, use nomsu -t format -"));
    filenames = a_List{"stdin"};
    end
    do -- for-loop
        for _i,filename in _ipairs(filenames) do
            file = read_file(filename);
    if (not file) then
        at_1_fail("@lib/tools/format.nom[805:843]",
        Text("File does not exist: ", filename)
    );
    end
    leadingx5Findent = file:matching("^\n*([ ]*)");
    code = NomsuCode_from(Source(filename, 1, (#file)), file);
    do
        local _fell_through = false
        local _result = {xpcall(function()
            tree = _1_parsed(code);
    formatted = (_1_as_nomsu(tree)):text():indented(leadingx5Findent);
            _fell_through = true
        end, enhance_error)}
        if _result[1] then
            -- Success:
    if not _fell_through then return table.unpack(_result, 2) end
        else
            -- Failure:
    
    msg = _result[2]
    if args.q then
        formatted = file;
    else
        say(msg);
    goto continue_filename;
    end
        end
    end
    if args.i then
        write_1_to_file(formatted, filename);
    else
        say_1_inline(formatted);
    end
            ::continue_filename::
        end
    end -- for-loop;
end);
if WAS_RUN_DIRECTLY then
    run_with(COMMAND_LINE_ARGS);
end
