#!/usr/bin/env nomsu -V7.0.0-- File lib/tools/install.nom chunk #1
-- 
-- A tool to install third party Nomsu packages
-- 
-- Usage:
--     nomsu -t install /path/to/package
--     nomsu -t install github.com/user/repo
-- ;
_ENV:use("filesystem");
_ENV:use("commandline");
_ENV:use("shell");

-- File lib/tools/install.nom chunk #2
local actions, download_1_with, run_command;
actions = a_List{};
download_1_with = (function(patts, cmd)
    actions:add(a_Dict{patterns = patts; cmd = cmd;});
end);
download_1_with(a_List{"^.*/([^/]+)%.git$"},
    Text("git clone %0 ", NOMSU_PACKAGEPATH, "/%1"));
download_1_with(a_List{"^.*/([^/]+)%.zip"},
    Text("curl %0 > ", NOMSU_PACKAGEPATH, "/%1.zip && unzip ", NOMSU_PACKAGEPATH,
      "/%1.zip -d ", NOMSU_PACKAGEPATH, " && rm ", NOMSU_PACKAGEPATH, "/%1.zip"));
download_1_with(a_List{"^.*/([^/]+)%.tar%.gz"},
    Text("curl %0 > ", NOMSU_PACKAGEPATH, "/%1.tar.gz && tar xf ", NOMSU_PACKAGEPATH,
      "/%1.tar.gz --directory ", NOMSU_PACKAGEPATH, " && rm ", NOMSU_PACKAGEPATH,
      "/%1.tar.gz"));
download_1_with(
    a_List{"^https://github%.com/([^/]+)/([^/]+)$", "^github%.com/([^/]+)/([^/]+)$"},
    Text("git clone https://github.com/%1/%2.git ", NOMSU_PACKAGEPATH, "/%2"));
download_1_with(
    a_List{"^https://bitbucket%.org/([^/]+)/([^/]+)$", "^bitbucket%.org/([^/]+)/([^/]+)$"},
    Text("git clone git@bitbucket.org:%1.git ", NOMSU_PACKAGEPATH, "/%2"));
run_command = (function(cmd)
    say(cmd);
    do
        local _fell_through = false
        local _result = {xpcall(function()
            at_1_sh_x3E("@lib/tools/install.nom[1301:1305]", cmd);
            _fell_through = true
        end, enhance_error)}
        if _result[1] then
            -- Success:
    if not _fell_through then return table.unpack(_result, 2) end
        else
            -- Failure:
    say(
        Text("Sorry, the install failed. You may need to re-run as root with `sudo` in front of the command."));
    exit(1);
        end
    end
end);
run_with = (function(args)
    local cmd;
    do -- for-loop
        for _i,filename in _ipairs(args.extras) do
            if Files.exists(filename) then
        run_command(Text("cp -rv ", filename, " ", NOMSU_PACKAGEPATH));
    goto continue_filename;
    else
        do -- for-loop
        for _i,action in _ipairs(actions) do
            do -- for-loop
        for _i,patt in _ipairs(action.patterns) do
            if filename:match(patt) then
        cmd = filename:with_1_x2Dx3E(patt, action.cmd);
    run_command(cmd);
    goto continue_filename;
    end
        end
    end -- for-loop;
        end
    end -- for-loop;
    end
    at_1_fail("@lib/tools/install.nom[1995:2037]",
        Text("Not sure what to do with ", filename)
    );
            ::continue_filename::
        end
    end -- for-loop;
end);
if WAS_RUN_DIRECTLY then
    run_with(COMMAND_LINE_ARGS);
end
