#!/usr/bin/env nomsu -V7.0.0-- File lib/tools/parse.nom chunk #1
-- 
-- Tool to print out a parse tree of files in an easy-to-read format. Usage:
-- nomsu tools/parse.nom file1 file2 directory1 ...        
-- ;
_ENV:use("filesystem");
_ENV:use("commandline");

-- File lib/tools/parse.nom chunk #2
local print_tree_1_at_indent, _1_as_xml, _1_as_lisp;
print_tree_1_at_indent = (function(t, indent)
    do --if $ is...
        local branch_valuex030 = t.type
        if branch_valuex030 == "Action" then
        say(Text(indent, "Action (", t.stub, "):"));
        do -- for-loop
            for _i,arg in _ipairs(t) do
                if SyntaxTree:is_instance(arg) then
            print_tree_1_at_indent(arg, Text(indent, "  "));
        end
            end
        end -- for-loop;
    elseif branch_valuex030 == "MethodCall" then
        say(Text(indent, "MethodCall on:"));
        print_tree_1_at_indent(t[1], Text(indent, "    "));
        print_tree_1_at_indent(t[2], Text(indent, "    "));
    elseif branch_valuex030 == "Number" then
        say(Text(indent, t[1]));
    elseif branch_valuex030 == "Var" then
        say(Text(indent, "$", t[1]));
    else
        say(Text(indent, t.type, ":"));
        do -- for-loop
            for _i,arg in _ipairs(t) do
                if SyntaxTree:is_instance(arg) then
            print_tree_1_at_indent(arg, Text(indent, "  "));
        else
            say(Text(indent, "  ", quote(arg)));
        end --when;
            end
        end -- for-loop;
    end --when
    end -- if $ is...;
end);
_1_as_xml = (function(_)
    local body;
    do --if $ is...
        local branch_valuex031 = type_of(_)
        if branch_valuex031 == "a Syntax Tree" then
        body = (a_List(function(add)
            do -- for-loop
                for _i,bit in _ipairs(_) do
                    add(_1_as_xml(bit));
                end
            end -- for-loop;
        end)):joined_with(" ");
        if (_.type == "Action") then
            do return Text("<Action name=\"", _1_as_xml(_:get_stub()), "\">", body, "</Action>") end
        else
            do return Text("<", _.type, ">", body, "</", _.type, ">") end
        end
    elseif branch_valuex031 == "Text" then
        do return (_:with_1_x2Dx3E("&", "&amp;")):with_1_x2Dx3E("\"", "&quot;"):with_1_x2Dx3E("'",
            "&apos;"):with_1_x2Dx3E("<", "&lt;"):with_1_x2Dx3E(">", "&gt;") end
    else
        do return Text(_) end
    end --when
    end -- if $ is...;
end);
_1_as_lisp = (function(_)
    local body;
    do --if $ is...
        local branch_valuex032 = type_of(_)
        if branch_valuex032 == "a Syntax Tree" then
        body = (a_List{_.type} + a_List(function(add)
            do -- for-loop
                for _i,bit in _ipairs(_) do
                    add(_1_as_lisp(bit));
                end
            end -- for-loop;
        end)):joined_with(" ");
        do return Text("(", body, ")") end
    elseif branch_valuex032 == "Text" then
        do return Text("\"",
          (_:with_1_x2Dx3E("\\", "\\\\")):with_1_x2Dx3E("\"", "\\\""):with_1_x2Dx3E("\n",
              "\\n"), "\"") end
    else
        do return Text(_) end
    end --when
    end -- if $ is...;
end);
run_with = (function(args)
    local file, nomsu, tree;
    do -- for-loop
        for _i,filename in _ipairs(args.extras) do
            file = read_file(filename);
    if (not file) then
        at_1_fail("@lib/tools/parse.nom[2287:2325]",
        Text("File does not exist: ", filename)
    );
    end
    nomsu = NomsuCode_from(Source(filename, 1, (#file)), file);
    tree = _1_parsed(nomsu);
    if (args.x or args.xml) then
        say(_1_as_xml(tree));
    elseif (args.l or args.lisp) then
        say(_1_as_lisp(tree));
    else
        print_tree_1_at_indent(tree, "");
    end --when;
        end
    end -- for-loop;
end);
if WAS_RUN_DIRECTLY then
    run_with(COMMAND_LINE_ARGS);
end
