#!/usr/bin/env nomsu -V7.0.0-- File lib/tools/tutorial.nom chunk #1
-- 
-- This is a Nomsu tutorial.
-- ;
_ENV:use("filesystem");
_ENV:use("consolecolor");
_ENV:use("commandline");
_ENV:use("progressbar");
_ENV:use("shell");
COMPILE_RULES["lesson"] = (function(_ENV, _tree, name, lesson)
    return LuaCode:from("@lib/tools/tutorial.nom[188:317]", "",
        LuaCode:from("@lib/tools/tutorial.nom[195:201]", "{name="),
        _ENV:_1_as_lua_expr(name),
        LuaCode:from("@lib/tools/tutorial.nom[221:230]", ", lesson="),
        quote((_1_as_nomsu(SyntaxTree(a_Dict{type = "FileChunks";}, lesson))):text()),
        LuaCode:from("@lib/tools/tutorial.nom[313:314]", "}"))
end);
COMPILE_RULES["< your code here >"] = (function(_ENV, _tree)
    return SyntaxTree{type="Action", source=Source("lib/tools/tutorial.nom", 373, 483), "at", _1_tree_with("Text", Text(_tree.source)), "fail", SyntaxTree{type="Text", source=Source("lib/tools/tutorial.nom", 437, 483), "Incomplete code: This needs to be filled in."}}
end)
COMPILE_RULES["???"] = COMPILE_RULES["< your code here >"];

-- File lib/tools/tutorial.nom chunk #2
local lessons, ask_normally;
lessons = a_List{
    {name="Variables", lesson="### In Nomsu, variables have a \"$\" prefix, and you can just assign to them\n    without declaring them first:\n$x = 1\ntest that ($x == 1)\n\n### Variables which have not yet been set have the value (nil)\ntest that ($not_yet_set == (nil))\n\n### Variables can be nameless:\n$ = 99\n\n### Or have spaces, if surrounded with parentheses:\n$(my favorite number) = 23\n\n### Figure out what value $my_var should have:\n$my_var = 100\n$my_var = ($my_var + $x + $(my favorite number))\ntest that ($my_var == (???))"},
        {name="Actions", lesson="### In Nomsu, actions are bits of code that run to produce a value or\n    do something. They have flexible syntax, so the values passed to\n    them can be interspersed with the action's name in any order.\n### Fix this action so the tests pass:\n($x doubled) means ((???) * $x)\n\n### Tests:\ntest that ((2 doubled) == 4)\ntest that ((-5 doubled) == -10)"},
        {name="Blocks", lesson="### When you need to do multiple things inside an action, use a block.\n### Blocks are written with a colon followed by some indented code:\n($x doubled then squared) means:\n    $x = (2 * $x)\n    $x = (???)\n    return $x\n\n### Blocks are also used for loops and conditionals:\nfor $num in [0, -1, 10, 4]:\n    $correct_answer = (4 * ($num * $num))\n    if (($num doubled then squared) != $correct_answer):\n        fail \"Wrong answer for \\($num)!\""},
        {name="Text", lesson="### Nomsu text is enclosed in double quotation marks:\n$text = \"Hello\"\n\n### You can insert values into text using a backslash:\ntest that (\"two plus three is \\(2 + 3)\" == (???))\n\n### Variables don't require parentheses, but other expressions do:\n$x = 99\ntest that (\"$x is \\$x\" == (???))\n\n### This can be used to convert values to text:\ntest that (\"\\$x\" == (???))\n\n### Longer strings use '(\"' followed by an indented region:\n$long = (\"\n    line one\n      line two with spaces at the front\n\")\n\ntest that\n    $long == (\"\n        \\(<your code here>)\n        \\(<your code here>)\n    \")"},
        {name="Conditionals", lesson="### Make this action return \"big\" if its argument is bigger\n    than 99, otherwise return \"small\"\n(the size of $n) means:\n    if (???):\n        <your code here>\n    ..else:\n        <your code here>\n\n### Tests:\nfor $big_number in [9999, 100]:\n    test that ((the size of $big_number) == \"big\")\n\nfor $small_number in [0, 1, -5, -999, 99]:\n    test that ((the size of $small_number) == \"small\")"},
        {name="Loops", lesson="### Fix this action so the tests pass:\n(the sum of $numbers) means:\n    $sum = 0\n    \n    ### You can loop over the values in a list like this:\n    for $number in $numbers:\n        ### Hint: math expressions may need parentheses\n        <your code here>\n    return $sum\n\n### Tests:\ntest that ((the sum of [1, 2, 3, 4, 5]) == 15)\ntest that ((the sum of [100, 200]) == 300)\n\n### You can also loop over a number range like this:\n$total = 0\nfor $i in (1 to 3):\n    $total = ($total + $i)\ntest that ($total == (???))"},
        {name="Variable Scopes", lesson="### Nomsu's variables are local by default, and actions have their own scopes:\n$x = 1\n$y = 2\n\n### Define an action that sets a variable:\n(do something) means:\n    ### The variable $y is never set in this action, so it has the same value\n        it has outside this action.\n    test that ($y == (???))\n    \n    ### $x is set inside this action, and actions have their own scopes.\n    $x = $y\n    \n    ### What number should $x be here?\n    test that ($x == (???))\n\n### After running the action, what value should $x have?\ndo something\ntest that ($x == (???))"},
        {name="More Variable Scopes", lesson="### Loops and conditionals do *not* have their own scopes:\n$z = 1\nif (1 == 1):\n    ### Set $z inside a conditional:\n    $z = 2\n\n### After assigning in a conditional, what should $z be?\ntest that ($z == (???))\nfor $ in (1 to 1):\n    ### Set $z inside a loop:\n    $z = 3\n\n### After assigning in a loop, what should $z be?\ntest that ($z == (???))"},
        {name="Externals", lesson="### The 'external' block lets you modify variables outside an action:\n$x = 1\n(do something) means:\n    external: $x = 2\ndo something\n\n### After running the action that sets $x in an 'external' block, what should $x be?\ntest that ($x == (???))"},
        {name="Locals", lesson="### The 'with' block lets you create a local scope for the variables you list:\n$y = 1\n$z = 1\nwith [$y]:\n    $y = 2\n    $z = 2\n\n### After setting $y and $z in the 'with [$y]' block, what should $y and $z be?\ntest that ($y == (???))\ntest that ($z == (???))"},
        {name="Failure and Recovery", lesson="$what_happened = \"nothing\"\n\n### In Nomsu, sometimes things fail, but you can recover from failures with 'try':\ntry:\n    ### The 'fail' action triggers failure\n    fail \"Oh no!\"\n..if it fails:\n    $what_happened = \"failure\"\n..if it succeeds:\n    $what_happened = \"success\"\n\n### What do you think happened?\ntest that ($what_happened == (???))\n\n### Note: a 'try' block will silence failures, so this has no effect:\ntry: fail"},
        {name="Indexing", lesson="### Nomsu uses the \".\" operator to access things inside an object:\n$dictionary = {.dog = \"A lovable doofus\", .cat = \"An internet superstar\"}\ntest that ($dictionary.dog == \"A lovable doofus\")\ntest that ($dictionary.cat == (???))\n\n### If you try to access a key that's not in an object, the result is (nil):\ntest that ($dictionary.mimsy == (???))\n\n### $dictionary.dog is just a shorthand for $dictionary.\"dog\".\n    You may need to use the longer form for strings with spaces:\n$dictionary.\"guinea pig\" = \"A real-life tribble\"\n\n### Dictionaries are created with curly braces ({}) and can have\n    anything as a key or value, including numbers or other dictionaries:\n$dictionary.5 = \"The number five\"\n$dictionary.five = 5\n$dictionary.myself = $dictionary\ntest that ($dictionary.myself == (???))\n\n### Lists are similar, but use square brackets ([])\n    and can only have numbers as keys, starting at 1:\n$list = [\"first\", \"second\", 999]\ntest that ($list.1 == \"first\")\ntest that ($list.2 == (???))\ntest that ($list.3 == (???))\n\n### Hint: 4 should be a missing key\ntest that ($list.4 == (???))\ntest that ($list.foobar == (???))\n\n### The \"#\" action gets the number of items inside something:\ntest that (#$list == (???))\ntest that (#{.x = 10, .y = 20} == (???))"},
        {name="Methods", lesson="### The \",\" is used for method calls, which means calling an action\n    that's stored on an object (with the object as the first argument).\n### Lists have an \"add\" method that puts new items at the end:\n$list = [-4, -6, 5]\n$list, add 3\ntest that ($list == [-4, -6, 5, 3])\n$list, add 7\ntest that ($list == [???])\n\n### Text also has some methods like:\n$name = \"Harry Tuttle\"\ntest that (($name, from 7 to 12) == \"Tuttle\")\ntest that (($name, with \"Tuttle\" -> \"Buttle\") == (???))\n\n### Methods can be chained too:\ntest that (($name, with \"Tuttle\" -> \"Buttle\", from 7 to 12) == (???))"},
        {name="Object Oriented Programming", lesson="### Object Oriented Programming deals with things that have\n    associated values and behaviors.\n### Here, we define a Buffer to be a thing that has a .bits value:\n(a Buffer) is (a thing) with [$bits]:\n    ### And some methods:\n    ($self, set up) means:\n        ### This method runs when a new buffer is created\n        $bits = []\n    \n    ### This method is used to add to a buffer\n    ($self, add $bit) means:\n        $bits, add $bit\n    \n    ### ($list, joined) is a list method that concatenates the list items:\n    ($self, as text) means ($bits, joined)\n    \n    ### Write a method called ($self, length) that returns the sum\n        of the lengths of each bit in the buffer:\n    <your code here>\n\n### Create an instance of a Buffer:\n$b = (a Buffer)\ntest that ($b is \"a Buffer\")\ntest that ((type of $b) is \"a Buffer\")\n$b, add \"xx\"\n$b, add \"yyy\"\ntest that (($b, as text) == \"xxyyy\")\ntest that (($b, length) == 5)\n\n### You can define a thing that inherits the behaviors of another thing like this:\n(a Backwards Buffer) is (a Buffer) with [$bits]:\n    ### ($list, reversed) is a method that returns a copy of $list with\n        the order of the items reversed.\n    ($self, as text) means ($bits, reversed, joined)\n$bb = (a Backwards Buffer)\n$bb, add \"one\"\n$bb, add \"two\"\ntest that (($bb, length) == (???))\ntest that (($bb, as text) == (???))"},
        {name="Files Part 1", lesson="### Define an external action here:\nexternal:\n    ### These will be used in the next lesson\n    $global_var = 23\n    ($x tripled) means:\n        <your code here>\n\ntest that ((5 tripled) == 15)\ntest that ((2 tripled) == 6)"},
        {name="Files Part 2", lesson="### 'use' is the action for importing from other files.\n### It takes the path to the file (without the .nom extension):\nuse (<prev lesson>)\ntest that ((10 tripled) == (???))\ntest that ($global_var == (???))"}
};
ask_normally = ask;
run_with = (function(args)
    local ask, tutorialx5Fdir, filename_of, filename, lessonx5Ftext, EDITOR, run_lesson, get_failures, show_first_failure_from, failures, currentx5Flesson, color, f, line, col, msg, files, newx5Ffiles, prevx5Fprogress, progress, N, k, p;
    if (args.help or args.h) then
        say(
        Text("Nomsu tutorial usage: nomsu -t tutorial [-x] [<location to put tutorial files>]"));
    exit();
    end
    say(
        bold(
            Text("\n", "    +------------------------------------+\n",
              "    |   Welcome to the Nomsu tutorial!   |\n",
              "    +------------------------------------+\n")));
    --  For this tutorial questions are hilighted in bold cyan:;
    ask = (function(q)
        return ask_normally(bold(cyan(q)))
    end);
    --  Find the tutorial file directory:;
    if ((#args.extras) == 0) then
        tutorialx5Fdir = "./nomsu_tutorial";
    if (not Files.exists(tutorialx5Fdir)) then
        do --if $ is...
        local branch_valuex033 = ask(
        Text("The Nomsu tutorial files will be in ", tutorialx5Fdir,
          " is that okay? [Y/n/exit] "))
        if branch_valuex033 == "n" or branch_valuex033 == "N" or branch_valuex033 == "no" then
        tutorialx5Fdir = ask("Where do you want to put the tutorial? ");
    elseif branch_valuex033 == "exit" or branch_valuex033 == "quit" or branch_valuex033 == "q" or branch_valuex033 == "e" then
        exit();
    end --when
    end -- if $ is...;
    end
    else
        tutorialx5Fdir = args.extras[1];
    end
    --  Set up the tutorial file directory:;
    if (not Files.exists(tutorialx5Fdir)) then
        make_directory(tutorialx5Fdir);
    end
    filename_of = (function(i)
        return (Text(tutorialx5Fdir, "/lesson", i, ".nom")):with_1_x2Dx3E("//", "/")
    end);
    do -- for-loop
        for i,lesson in pairs(lessons) do
            filename = filename_of(i);
    if (not Files.exists(filename)) then
        lessonx5Ftext = lesson.lesson:with_1_x2Dx3E("%(<prev lesson>%)",
        Text("\"",
          (filename_of(i - 1)):with_1_x2Dx3E("%.nom$", ""):with_1_x2Dx3E("^%./", ""), "\""));
    write_1_to_file(lessonx5Ftext, filename);
    end
        end
    end -- for-loop;
    --  Display info about editing the tutorial files:;
    if args.x then
        say(
        Text("The tutorial files are located in ", tutorialx5Fdir, ".\n",
          "You're in charge of editing them yourself."));
    else
        EDITOR = os.getenv("EDITOR");
    if EDITOR then
        do --if $ is...
        local branch_valuex035 = ask(
        Text(EDITOR,
          " is your system editor, would you like this tutorial to use it? [Y/n] "))
        if branch_valuex035 == "n" or branch_valuex035 == "N" or branch_valuex035 == "no" then
        EDITOR = (nil);
    end --when
    end -- if $ is...;
    end
    if (not EDITOR) then
        say();
    EDITOR = ask(
        Text("What program would you like to use to edit tutorial files?\n",
          "(leave blank if you want to edit on your own in a different window)\n", "> "));
    if (EDITOR == "") then
        EDITOR = (nil);
    end
    end
    end
    say(
        Text("\n", "For this tutorial, a set of files has been created in ",
          tutorialx5Fdir, ".\n",
          "Each file corresponds to a lesson. Your task is to fix each file\n",
          "so that it passes the tests.\n"));
    run_lesson = (function(i)
        local filename, file, tree;
        filename = filename_of(i);
        file = read_file(filename);
        file = NomsuCode:from(Source(filename, 1, (#file)), file);
        tree = _1_parsed(file);
        tree = tree:with(
            (function(_)
                if (_ == SyntaxTree{type="Action", source=Source("lib/tools/tutorial.nom", 14486, 14499), "<", "prev", "lesson", ">"}) then
                    do return _1_tree_with("Text", (filename_of(i - 1)):with_1_x2Dx3E("%.nom$", "")) end
                end
            end));
        _ENV:run(tree);
    end);
    get_failures = (function()
        return a_List(function(add)
            local msg;
            do -- for-loop
                for i,lesson in pairs(lessons) do
                    do
                local _fell_through = false
                local _result = {xpcall(function()
                    run_lesson(i);
                    _fell_through = true
                end, enhance_error)}
                if _result[1] then
                    -- Success:
            if not _fell_through then return table.unpack(_result, 2) end
                else
                    -- Failure:
            
            msg = _result[2]
            msg = msg:with_1_x2Dx3E("\n *stack traceback:.*", "");
            add(a_Dict{lesson_number = i; failure = msg;});
                end
            end
                end
            end -- for-loop;
        end)
    end);
    say(bold("Lessons:"));
    show_first_failure_from = (function(failures)
        say(
            Text("\n", bold("Next thing to fix:"), " ",
              bold(
                  yellow(
                      Text("Lesson ", failures[1].lesson_number, ": ",
                        lessons[failures[1].lesson_number].name))), "\n\n",
              failures[1].failure:indented(), "\n"));
    end);
    failures = get_failures();
    currentx5Flesson = (nil);
    do -- for-loop
        for i,lesson in pairs(lessons) do
            do -- for-loop
        for _i,f in _ipairs(failures) do
            if (f.lesson_number == i) then
        color = ((function()
        if currentx5Flesson then
            return red()
        else
            return yellow()
        end
    end)());
    currentx5Flesson = (currentx5Flesson or i);
    say(
        Text(color, "  - ", bold(Text(color, i, ". ", lesson.name, " [incomplete]"))));
    goto continue_lesson;
    end
        end
    end -- for-loop;
    say(Text(green("  + "), bold(green(Text(i, ". ", lesson.name, " [passed]")))));
            ::continue_lesson::
        end
    end -- for-loop;
    if COLOR_ENABLED then
        say(
        Text("\n", bold("Your progress:"), " ",
          _1_wide_2_progress_bar(20, (((#lessons)) - ((#failures))) / ((#lessons)))));
    else
        say();
    say(_1_x2F_2_progress_bar(((#lessons)) - ((#failures)), (#lessons)));
    end
    while (not ((#failures) == 0)) do
        show_first_failure_from(failures);
    --  Have the user fix the first failure:;
    if EDITOR then
        --  If the user is using $EDITOR, launch it so they can edit the file:;
    filename = filename_of(failures[1].lesson_number);
    ::label_retry_file::;
    do --if $ is...
        local branch_valuex03B = ask(Text("Edit ", filename, " to get it to pass? [Y/n/exit] "))
        if branch_valuex03B == "q" or branch_valuex03B == "quit" or branch_valuex03B == "exit" or branch_valuex03B == "n" or branch_valuex03B == "N" or branch_valuex03B == "no" then
        exit();
    elseif branch_valuex03B == "c" then
        write_1_to_file("# cheater!\n", filename);
    elseif branch_valuex03B == "y" or branch_valuex03B == "Y" or branch_valuex03B == "yes" or branch_valuex03B == "" then
        f = read_file(filename);
        line, col = failures[1].failure:match(":(%d+),(%d+)");
        if (line and col) then
            if EDITOR:matches("vim$") then
            at_1_sh_x3E("@lib/tools/tutorial.nom[17772:17822]",
                Text(EDITOR, " ", filename, " '+call cursor(", line, ",", col, ")'"));
        elseif EDITOR:matches("nano$") then
            at_1_sh_x3E("@lib/tools/tutorial.nom[17944:17979]",
                Text(EDITOR, " +", line, ",", col, " ", filename));
        elseif EDITOR:matches("emacs$") then
            at_1_sh_x3E("@lib/tools/tutorial.nom[18102:18137]",
                Text(EDITOR, " +", line, ":", col, " ", filename));
        else
            at_1_sh_x3E("@lib/tools/tutorial.nom[18237:18258]", Text(EDITOR, " ", filename));
        end --when;
        else
            at_1_sh_x3E("@lib/tools/tutorial.nom[18315:18336]", Text(EDITOR, " ", filename));
        end
    else
        say("Sorry, I don't understand that.");
        goto label_retry_file;
    end --when
    end -- if $ is...;
    do
        local _fell_through = false
        local _result = {xpcall(function()
            run_lesson(failures[1].lesson_number);
            _fell_through = true
        end, enhance_error)}
        if _result[1] then
            -- Success:
    if not _fell_through then return table.unpack(_result, 2) end
        else
            -- Failure:
    
    msg = _result[2]
    failures[1].failure = msg;
    say(bold(red("\n There's a bit more to fix:")));
    msg = msg:with_1_x2Dx3E("\n *stack traceback:.*", "");
    say(msg:indented());
    say();
    goto label_retry_file;
        end
    end
    else
        --  If the user is using an external editor, wait for the file to change;
    filename = filename_of(failures[1].lesson_number);
    say(
        Text(yellow("Waiting for you to fix "), bold(filename), " ",
          yellow("(press ctrl+c to exit)...")));
    do
        local _fell_through = false
        local _result = {xpcall(function()
            files = a_List(function(add)
        do -- for-loop
            local _start = 1
        for _=_start,(#lessons) do
                add(read_file(filename_of(_)));
            end
        end -- for-loop;
    end);
    while (true) do
        sleep_for_1_seconds(0.5);
    newx5Ffiles = a_List(function(add)
        do -- for-loop
            local _start = 1
        for _=_start,(#lessons) do
                add(read_file(filename_of(_)));
            end
        end -- for-loop;
    end);
    if (newx5Ffiles ~= files) then
        files = newx5Ffiles;
    break;
    end
    end --while-loop;
            _fell_through = true
        end, enhance_error)}
        if _result[1] then
            -- Success:
    if not _fell_through then return table.unpack(_result, 2) end
        else
            -- Failure:
    say("\nGoodbye.");
    exit();
        end
    end
    end
    prevx5Fprogress = (((#lessons)) - ((#failures))) / ((#lessons));
    failures = get_failures();
    progress = (((#lessons)) - ((#failures))) / ((#lessons));
    --  Update the progressbar if progess has changed:;
    if (progress ~= prevx5Fprogress) then
        if (progress > prevx5Fprogress) then
        say(bold(green("\nSuccess!\n")));
    else
        say(bold(red("\nUh oh, that broke something.\n")));
    end
    if COLOR_ENABLED then
        N = 100;
    do -- for-loop
        local _start = 0
    for _=_start,N do
            k = _1_smoothed_by(_ / N, 2);
    p = _1_to_2_mixed_by(prevx5Fprogress, progress, k);
    say_1_inline(
        Text("\013", bold("Your progress:"), " ", _1_wide_2_progress_bar(20, p)));
    io.flush();
    sleep_for_1_seconds(1 / N);
        end
    end -- for-loop;
    else
        say(_1_x2F_2_progress_bar(((#lessons)) - ((#failures)), (#lessons)));
    end
    say();
    end
    end --while-loop;
    --  All done, no more failures:;
    say(
        Text("\n", "            ", bold(Text(slow_blink("Congratulations!"))), "\n\n",
          "       You've passed the tutorial!\n\n", "                \\(^",
          (COLOR_ENABLED and "\225\180\151" or "_"), "^)/\n\n"));
end);
if WAS_RUN_DIRECTLY then
    run_with(COMMAND_LINE_ARGS);
end
