#!/usr/bin/env nomsu -V7.0.0-- File lib/tools/uninstall.nom chunk #1
-- 
-- A tool to uninstall third party Nomsu packages (the inverse of the install tool)
-- 
-- Usage:
--     nomsu -t uninstall <package_names...>
-- ;
_ENV:use("filesystem");
_ENV:use("commandline");
_ENV:use("shell");

-- File lib/tools/uninstall.nom chunk #2
local run_command;
run_command = (function(cmd)
    say(cmd);
    do
        local _fell_through = false
        local _result = {xpcall(function()
            at_1_sh_x3E("@lib/tools/uninstall.nom[376:380]", cmd);
            _fell_through = true
        end, enhance_error)}
        if _result[1] then
            -- Success:
    if not _fell_through then return table.unpack(_result, 2) end
        else
            -- Failure:
    say(
        Text("Sorry, the uninstall failed. You may need to re-run as root with `sudo` in front of the command."));
    exit(1);
        end
    end
end);
run_with = (function(args)
    local searchpath, path;
    searchpath = (a_List(function(add)
        do -- for-loop
            for _i,_ in _ipairs(a_List{"?.lua", "?/init.lua", "?.nom", "?/init.nom"}) do
                add(Text(NOMSU_PACKAGEPATH, _));
            end
        end -- for-loop;
    end)):joined_with(";");
    do -- for-loop
        for _i,packagex5Fname in _ipairs(args.extras) do
            path = package.searchpath(packagex5Fname, package.nomsupath, "/");
    if (not path) then
        say(Text("Sorry, couldn't find ", packagex5Fname, " in ", NOMSU_PACKAGEPATH));
    exit(1);
    end
    path = path:with_1_x2Dx3E("/init%.nom", "");
    if (not (ask(Text("Do you want to delete ", path, "? [Y/n] ")) == "n")) then
        run_command(Text("rm -rv ", path));
    end
        end
    end -- for-loop;
end);
if WAS_RUN_DIRECTLY then
    run_with(COMMAND_LINE_ARGS);
end
