#!/usr/bin/env nomsu -V7.0.0-- File lib/tools/upgrade.nom chunk #1
-- 
-- Tool to automatically update code from old versions of Nomsu. Usage:
-- nomsu tools/upgrade.nom [-i] file1 file2 directory1 ...
-- If "-i" is the first argument, upgrades will be performed in-place. Otherwise, the
-- upgraded code will be printed.
-- ;
_ENV:use("compatibility");
_ENV:use("filesystem");
_ENV:use("consolecolor");
_ENV:use("commandline");

-- File lib/tools/upgrade.nom chunk #2
run_with = (function(args)
    local inplace, startx5Fversion, version, test, file, leadingx5Findent, code, tree, uptree, text;
    inplace = (args.i or args.inplace);
    startx5Fversion = args["upgrade-from"];
    if startx5Fversion then
        do
        local _fell_through = false
        local _result = {xpcall(function()
            _ENV:use(startx5Fversion);
            _fell_through = true
        end, enhance_error)}
        if _result[1] then
            -- Success:
    if not _fell_through then return table.unpack(_result, 2) end
        else
            -- Failure:
    
        end
    end
    end
    version = (args["upgrade-to"] or NOMSU_VERSION);
    test = (args.t or args.test);
    do -- for-loop
        for _i,filename in _ipairs(args.extras) do
            file = read_file(filename);
    if (not file) then
        at_1_fail("@lib/tools/upgrade.nom[839:877]",
        Text("File does not exist: ", filename)
    );
    end
    leadingx5Findent = file:matching("\n*([ ]*)");
    code = NomsuCode_from(Source(filename, 1, (#file)), file);
    tree = _1_parsed(code, startx5Fversion);
    uptree = _1_upgraded_from_2_to(tree, (startx5Fversion or (tree.version or NOMSU_VERSION)),
        version);
    text = Text(leadingx5Findent,
      (_1_as_nomsu(uptree)):text():with_1_x2Dx3E("\n", Text("\n", leadingx5Findent)));
    if inplace then
        say(Text("Upgraded ", filename));
        write_1_to_file(text, filename);
    elseif test then
        if (uptree == tree) then
            say(dim(Text(filename, " will not be changed")));
        else
            say(bright(Text(filename, " will be changed")));
        end
    else
        say_1_inline(text);
    end --when;
        end
    end -- for-loop;
end);
if WAS_RUN_DIRECTLY then
    run_with(COMMAND_LINE_ARGS);
end
